*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/cmd_list.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function init_list()
*+               STATIC Function no_ast()
*+               STATIC Function xno_ast()
*+               Function cmd_list()
*+               Function fnc_list()
*+               Function op_list()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

*---------------------------------------------------------------------------
* 
*---------------------------------------------------------------------------
STATIC cmd_list
STATIC cmd_count

STATIC fnc_list
STATIC fnc_count

STATIC op_list
STATIC op_count


****************************************************************************
FUNCTION init_list( cFullPath )
// this function initializes the STATIC arrays from the CLICK.INI file,
// and creates several forms of the COMMAND array.
****************************************************************************
LOCAL retval1
LOCAL retval2
LOCAL ast_list
LOCAL non_upper
LOCAL nPointer
//local cFullPath := if( file( 'CLICK.INI' ), 'CLICK', rootname( ft_origin() ) ) + '.INI'

/*
Read in the command list, sort it (ignoring *) and develop three arrays.
1 is the command list, forced to upper case.
2 is the command list without case changes.
3 is the logic array for the * marks.
*/
show_in( 'Reading COMMAND list' )
cmd_list  := readlist( cFullPath, 'CMD_LIST' )
cmd_count := LEN( cmd_list )
FOR nPointer = 1 TO cmd_count
  cmd_list[ nPointer ] := ALLTRIM( cmd_list[ nPointer ] )
NEXT nPointer
show_in( 'Sorting COMMAND List' )
// cmd_list  := asort( cmd_list,,, { | x, y | no_ast( x ) < no_ast( y ) } )
cmd_list  := quicksort( cmd_list, { | x | no_ast( x ) } )
non_upper := ACLONE( cmd_list )
ast_list  := ARRAY( LEN( cmd_list ) )
FOR nPointer = 1 TO cmd_count
  IF LEFT( cmd_list[ nPointer ], 1 ) == '*'
    cmd_list[ nPointer ]  := UPPER( SUBSTR( cmd_list[ nPointer ], 2 ) )
    non_upper[ nPointer ] := SUBSTR( non_upper[ nPointer ], 2 )
    ast_list[ nPointer ]  := .T.
  ELSE
    cmd_list[ nPointer ] := UPPER( cmd_list[ nPointer ] )
    ast_list[ nPointer ] := .F.
  ENDIF
NEXT nPointer

retval1 := non_upper
show_in( 'Reading FUNCTION List' )
fnc_list  := readlist( cFullPath, 'FUNC_LIST' )
fnc_count := LEN( fnc_list )
FOR nPointer = 1 TO fnc_count
  IF LEN( fnc_list[ nPointer ] ) < 4
    fnc_list[ nPointer ] := PAD( fnc_list[ nPointer ], 4 )
  ENDIF
NEXT nPointer
show_in( 'Sorting FUNCTION List' )
// fnc_list  := asort( fnc_list,,, { | x, y | upper( x ) < upper( y ) } )
fnc_list  := quicksort( fnc_list, { | x | UPPER( x ) } )
non_upper := ACLONE( fnc_list )
FOR nPointer := 1 TO fnc_count
  fnc_list[ nPointer ] := UPPER( fnc_list[ nPointer ] )
NEXT nPointer

retval2 := non_upper

show_in( 'Reading OPERATOR List' )
op_list  := readlist( cFullPath, 'OP_LIST' )
op_count := LEN( op_list )
// op_list  := asort( op_list )
op_list := quicksort( op_list )

RETURN { retval1, retval2, ast_list }

// function re-instated 13Dec'98 (DJW)
// because version in no_ast.c converts the contents
// of the actual variable passed to upper case
// (no wonder it's faster!)
//


****************************************************************************
STATIC FUNCTION no_ast( cWord )
// This function is for the above function only, and allows the sort
// to ignore the '*' if it exists as the first letter of a command.
****************************************************************************
RETURN UPPER( IF( LEFT( cWord, 1 ) == '*', SUBSTR( cWord, 2 ), cWord ) )


****************************************************************************
STATIC FUNCTION xno_ast( cWord )
****************************************************************************
RETURN no_ast( cWord )


****************************************************************************
FUNCTION cmd_list( cWord, nPointer )
// This seeks the word in the list and returns the pointer by reference.
// The function returns whether or not the seek was successful.
// This is a binary seek into a sorted array.
****************************************************************************
LOCAL retval   := .F.
LOCAL nWordLen := LEN( cWord )
LOCAL nLo      := 0
LOCAL nHi      := cmd_count + 1
LOCAL lTwoWord := ' ' $ cWord
LOCAL lShort   := nWordLen < 4

cWord := UPPER( ALLTRIM( cWord ) )
IF lShort
  cWord += ' '
ENDIF

IF nWordLen > 1
  nPointer := INT( cmd_count / 2 )
  DO WHILE nHi > nLo + 1
    IF lShort
      IF cWord == cmd_list[ nPointer ] + ' '
        retval := .T.
        EXIT
      ELSEIF cWord < cmd_list[ nPointer ] + ' '
        nHi := nPointer
      ELSEIF cWord > cmd_list[ nPointer ] + ' '
        nLo := nPointer
      ENDIF
    ELSE
      IF cWord == PAD( cmd_list[ nPointer ], nWordLen )
        retval := .T.
        EXIT
      ELSEIF cWord < PAD( cmd_list[ nPointer ], nWordLen )
        nHi := nPointer
      ELSEIF cWord > PAD( cmd_list[ nPointer ], nWordLen )
        nLo := nPointer
      ENDIF
    ENDIF
    nPointer := INT( nLo + ( ( nHi - nLo ) / 2 ) )
  ENDDO
ENDIF

IF retval .AND. .NOT. lTwoWord .AND. SPACE( 1 ) $ TRIM( cmd_list[ nPointer ] )
  retval := .F.
ENDIF
RETURN retval   //cmd_list()


****************************************************************************
FUNCTION fnc_list( cWord, nPointer )
// This seeks the word in the list and returns the pointer by reference.
// The function returns whether or not the seek was successful.
// This is a binary seek into a sorted array.
****************************************************************************
LOCAL retval   := .F.
LOCAL nWordLen := LEN( cWord )
LOCAL nLo      := 0
LOCAL nHi      := fnc_count + 1
IF nWordLen > 1
  cWord := UPPER( cWord )
  IF nWordLen < 4
    cWord    := PAD( cWord, 4 )
    nWordLen := 4
  ENDIF
  nPointer := INT( fnc_count / 2 )
  DO WHILE nHi > nLo + 1
    IF cWord == PAD( fnc_list[ nPointer ], nWordLen )
      retval := .T.
      EXIT
    ELSEIF cWord < PAD( fnc_list[ nPointer ], nWordLen )
      nHi := nPointer
    ELSEIF cWord > PAD( fnc_list[ nPointer ], nWordLen )
      nLo := nPointer
    ENDIF
    nPointer := INT( nLo + ( ( nHi - nLo ) / 2 ) )
  ENDDO
ENDIF
RETURN retval   //fnc_list()


****************************************************************************
FUNCTION op_list( cWord, nPointer )
// This seeks the word in the list and returns the pointer by reference.
// The function returns whether or not the seek was successful.
// This is a binary seek into a sorted array.
****************************************************************************
LOCAL retval   := .F.
LOCAL nWordLen := LEN( cWord )
LOCAL nLo      := 0
LOCAL nHi      := op_count + 1
nPointer := INT( op_count / 2 )
IF nWordLen > 0
  DO WHILE nHi > nLo + 1
    IF cWord == op_list[ nPointer ]
      retval := .T.
      EXIT
    ELSEIF cWord < op_list[ nPointer ]
      nHi := nPointer
    ELSEIF cWord > op_list[ nPointer ]
      nLo := nPointer
    ENDIF
    nPointer := INT( nLo + ( ( nHi - nLo ) / 2 ) )
  ENDDO
ENDIF
RETURN retval   //op_list()
