*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/declbust.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Procedure declbust()
*+               STATIC Function stripcomnt()
*+               Function tab2space()
*+               Function nextcomma()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include "directry.ch"
#include "common.ch"
#include "inkey.ch"

#define drivesep "/"  //separated this for future windows version
#define dirsep "/"
#define CVERSION '2.03H'
#define newline  11

*+--------------------------------------------------------------------
*+    Procedure declbust()
*+    Called from ( click.prg    )   1 - procedure click()
*+       Calls    ( obufread.prg )   1 - function bclose()
*+                ( obufread.prg )   2 - function beof()
*+                ( obufread.prg )   1 - function binit()
*+                ( obufread.prg )   4 - function blinenumber()
*+                ( obufread.prg )   1 - function bopen()
*+                ( obufwrit.prg )   1 - procedure bo_close()
*+                ( obufwrit.prg )   1 - function bo_init()
*+                ( obufwrit.prg )   1 - function bo_open()
*+                ( obufwrit.prg )  16 - procedure bo_write()
*+                ( obufread.prg )   4 - function breadline()
*+                ( obufread.prg )   1 - function brelative()
*+                ( click.prg    )   3 - function lineparse()
*+                ( declbust.prg )   2 - function nextcomma()
*+                ( profile.prg  )   4 - function profilestring()
*+                ( click.prg    )   1 - procedure setlinecont()
*+                ( click.prg    )   1 - procedure show_out()
*+                ( declbust.prg )   3 - STATIC function stripcomnt()
*+                ( declbust.prg )   1 - function tab2space()
*+                ( click.prg    )   1 - function tabspstrip()
*+--------------------------------------------------------------------
PROCEDURE declbust( cThisFile, cOutFile, cClickini )

LOCAL cThisLine
LOCAL cThisCommand
LOCAL cEndOfLine
LOCAL y
LOCAL z
LOCAL oOutHandle
LOCAL aLocals
LOCAL nPointer
LOCAL cComment
LOCAL lStatFunc
LOCAL cTempVar
LOCAL aPreCombined
LOCAL nPreCombined
LOCAL oBuffObj3
LOCAL nOldPcntDone
LOCAL nPcntDone
LOCAL nLineLen
LOCAL nLocalLen
LOCAL lWorkDone    := .F.
LOCAL aParts       := {}
LOCAL lClickIgnore := .f., lopen
LOCAL lCommentMode := .F.
LOCAL aLine        := {}
LOCAL aType        := {}
LOCAL aParse       := {}
LOCAL n
LOCAL cStripLine
LOCAL cUStripLine
LOCAL cOutput
LOCAL lConvertDo   := ProfileString( cClickini, 'CLICK', 'CONVERT_OLD_STYLE_FUNCTIONS', 'NO' ) == 'YES'
LOCAL lConvertInc  := ProfileString( cClickini, 'CLICK', 'CONVERT_TO_INCREMENTOR', 'YES' ) == 'YES'
LOCAL lCleanInc    := ProfileString( cClickini, 'CLICK', 'CLEAN_UP_INCLUDES', 'YES' ) == 'YES'
LOCAL lDeflate5    := ProfileString( cClickini, 'CLICK', 'DEFLATE_+', 'NO' ) == 'YES'

show_out( 'Declaration Buster,  Version ' + CVERSION )
oBuffObj3 := bInit( cThisFile )
lopen     := Bopen( oBuffObj3 )   //call bopen to set the crlf from original file
FERASE( cOutFile )
oOutHandle := bo_init( cOutFile,, oBuffObj3[ newline ], cClickini )
IF bo_open( oOutHandle )

  // open the file for buffered reading
  IF lopen  //bopen( oBuffObj3 ) had to open early to get eol character(s)

    nPcntDone := 0

    // work on this file until all lines are read
    DO WHILE !beof( oBuffObj3 )   //enddo around 453

      // get the next line from the buffered read
      cThisLine := bReadLine( oBuffObj3 )
      @  6, 67 SAY STR( bLineNumber( oBuffObj3 ), 8 )

      nOldPcntDone := nPcntDone
      nPcntDone    := INT( bRelative( oBuffObj3 ) * 50 )
      IF nOldPcntDone <> nPcntDone
        @  6, 14 SAY REPLICATE( '', nPcntDone ) COLOR IIF( lWorkDone, 'R+/B', 'GR+/B' )
      ENDIF

      IF EMPTY( cThisLine )
        bo_write( oOutHandle, oBuffObj3[ newline ] )
        LOOP
      ENDIF

      cStripLine  := TabSpStrip( cThisLine )
      cUStripLine := UPPER( cStripLine )

      // pay attention to the 'skip me' flags.
      IF cUStripLine == '*+CLICKOFF' .OR. cUStripLine == 'TEXT'
        lClickIgnore := .T.
      ENDIF

      IF lClickIgnore
        bo_write( oOutHandle, cThisLine + oBuffObj3[ newline ] )
        IF cUStripLine == '*+CLICKON' .OR. cUStripLine == 'ENDTEXT' .OR. ;
                  bEof( oBuffObj3 )
          lClickIgnore := .F.
        ENDIF
        LOOP
      ENDIF

      IF LEFT( cUStripLine, 1 ) == '*'
        IF lCommentMode .AND. AT( '*/', cThisLine ) > 0
          lCommentMode := .F.
        ENDIF
        bo_write( oOutHandle, cThisLine + oBuffObj3[ newline ] )
        LOOP
      ENDIF

      // write comments directly.
      IF LEFT( cStripLine, 2 ) == '//|&&'
        IF lCommentMode .AND. AT( '*/', cThisLine ) > 0
          lCommentMode := .F.
        ENDIF
        bo_write( oOutHandle, cThisLine + oBuffObj3[ newline ] )
        LOOP
      ENDIF

      IF !lCommentMode
        aParts := lineparse( cStripLine )
        aLine  := aParts[ 1 ]
        aType  := aParts[ 2 ]
      ENDIF

      // write # directives and loop

      nLineLen := LEN( aLine )

      IF aLine[ 1 ] == '#'

        IF lCleanInc .AND. nLineLen > 4 .AND. UPPER( aLine[ 3 ] ) == 'INCLUDE'

          aLine[ 3 ] := LOWER( aLine[ 3 ] )
          aLine[ 5 ] := STRTRAN( UPPER( aLine[ 5 ] ), "'", '"' )

        ENDIF

        IF aLine[ 2 ] == ' '

          ADEL( aLine, 2 )
          ADEL( aType, 2 )

          ASIZE( aLine, LEN( aLine ) - 1 )
          ASIZE( aType, LEN( aType ) - 1 )

          cThisLine := ''

          nLineLen := LEN( aLine )
          FOR n := 1 TO nLineLen
            cThisLine += aLine[ n ]
          NEXT

        ENDIF

        bo_write( oOutHandle, LTRIM( cThisLine ) + oBuffObj3[ newline ] )
        IF ASCAN( aType, 'LC' ) > 0
          DO WHILE .T.
            cThisLine := bReadLine( oBuffObj3 )
            @  6, 67 SAY STR( bLineNumber( oBuffObj3 ), 8 )
            bo_write( oOutHandle, cThisLine + oBuffObj3[ newline ] )
            aParse := lineparse( cThisLine )
            aLine  := aParse[ 1 ]
            aType  := aParse[ 2 ]
            IF ASCAN( aType, 'LC' ) == 0
              EXIT
            ENDIF
          ENDDO
        ENDIF
        LOOP
      ENDIF

      setlinecont( aType )

      // Check for /* and */ comments and skip them

      IF lCommentMode
        IF AT( '*/', cThisLine ) > 0
          lCommentMode := .F.
        ENDIF
        bo_write( oOutHandle, cThisLine + oBuffObj3[ newline ] )
        LOOP
      ELSE
        IF ATAIL( aType ) == '/*'
          lCommentMode := .T.
        ENDIF
      ENDIF

      // Strip the tabs out of this line.
      cThisLine := ''
      nLineLen  := LEN( aLine )
      FOR n := 1 TO nLineLen
        IF aType[ n ] == 'S'  // don't strip tabs from inside of strings.
          cThisLine += aLine[ n ]
        ELSE
          cThisLine += tab2space( aLine[ n ] )
        ENDIF
      NEXT

      aParts := stripcomnt( cThisLine )

      cThisLine := aParts[ 1 ]
      cComment  := aParts[ 2 ]

      // check to see if the line is a declaration line

      IF PAD( UPPER( ALLTRIM( cThisLine ) ), 4 ) $ ;
             'LOCA|PRIV|MEMV|STAT|PUBL|FIEL|REPL|METH|CLAS'
      ENDIF

      DO CASE
      CASE nLineLen > 0 .AND. aType[ 1 ] $ 'CT' .AND. ;
          PAD( UPPER( ALLTRIM( cThisLine ) ), 4 ) $ ;
          'LOCA|PRIV|MEMV|STAT|PUBL|FIEL|REPL|METH|CLAS'

        // this checks to see if this line has a continuation -> ;
        // and if so it grabs the rest of the pieces and
        // creates a single long line out of them.

        // it also gathers an array of all the lines before they
        // get combined, so if there is nothing to do, we can
        // put them back the way they started.

        cThisline    := ALLTRIM( cThisline )
        aPreCombined := { cThisLine + ' ' + cComment }
        nPreCombined := 1
        DO WHILE RIGHT( cThisLine, 1 ) == ';'

          cThisLine := LEFT( cThisLine, LEN( cThisLine ) - 1 )
          cTempVar  := bReadLine( oBuffObj3 )
          @  6, 67 SAY STR( bLineNumber( oBuffObj3 ), 8 )

          AADD( aPreCombined, cTempVar )
          nPreCombined ++

          aParts   := stripcomnt( cTempVar )
          cTempVar := aParts[ 1 ]
          cComment += aParts[ 2 ]

          cThisLine += ALLTRIM( cTempVar )

        ENDDO

        // check for STATIC FUNCTION's, yet another overloaded term!
        lStatFunc := .F.
        // find out where second word starts
        nPointer := AT( ' ', cThisLine )
        IF UPPER( LEFT( cThisline, 4 ) ) == 'STAT'
          IF UPPER( LEFT( SUBSTR( cThisline, nPointer + 1 ), 4 ) ) == 'FUNC'
            lStatFunc := .T.
          ENDIF
        ENDIF

        // check to see if we can skip this declaration
        // because it only has one part

        IF AT( ',', cThisLine ) == 0 .OR. ;
              nextcomma( cThisLine ) == 0 .OR. ;
              lStatFunc .OR. ;
              ASCAN( aLine, { | ww | UPPER( ww ) == 'ALL' } ) > 0 .OR. ;
              ASCAN( aLine, { | ww | UPPER( ww ) == 'NEXT' } ) > 0 .OR. ;
              ASCAN( aLine, { | ww | UPPER( ww ) == 'WHILE' } ) > 0 .OR. ;
              ASCAN( aLine, { | ww | UPPER( ww ) == 'FOR' } ) > 0

          // No need to break this one up, so just write it
          // from data gathered before it was assembled from
          // multiple lines.

          FOR z := 1 TO nPreCombined
            bo_write( oOutHandle, aPreCombined[ z ] + oBuffObj3[ newline ] )
          NEXT

        ELSE

          // once we get to here, we have found a line which
          // needs to be broken apart.

          // first, we grab the declaration command off of the
          // left end of the line.

          DO CASE
          CASE UPPER( LEFT( cThisLine, 9 ) ) == 'CLASS VAR'
            IF 'READONLY' $ UPPER( cThisLine )
              cThisCommand := 'CLASS VAR READONLY'
              cThisLine    := SUBSTR( cThisLine, 11 )
              cThisLine    := STUFF( cThisLine, AT( 'READONLY', UPPER( cThisLine ) ), 8, '' )
            ELSE
              cThisCommand := LEFT( cThisLine, 9 )
              cThisLine    := SUBSTR( cThisLine, 11 )
            ENDIF

          CASE UPPER( LEFT( cThisLine, 12 ) ) == 'CLASS METHOD'
            cThisCommand := LEFT( cThisLine, 12 )
            cThisLine    := SUBSTR( cThisLine, 14 )
          OTHERWISE
            cThisCommand := LEFT( cThisLine, AT( ' ', cThisLine ) - 1 )
            cThisLine    := SUBSTR( cThisLine, LEN( cThisCommand ) + 1 )
          ENDCASE

          // now, we go throught the line and seperate each
          // declaration into the aLocals array
          aLocals := {}

          DO WHILE .T.

            // this gets the next divider comma
            nPointer := nextcomma( cThisLine )

            // if nPoiner is still greater than 0, there are still
            // more parts to seperate

            IF nPointer > 0
              // grab off this piece and put it on the array
              AADD( aLocals, LEFT( cThisLine, nPointer - 1 ) )
              // then trim it off of the working line
              cThisLine := SUBSTR( cThisLine, nPointer + 1 )
            ELSE
              // this is the last one!
              AADD( aLocals, cThisLine )
              EXIT
            ENDIF

          ENDDO

          // now, write the output to the file in seperate pieces

          nLocalLen := LEN( aLocals )
          FOR y := 1 TO nLocalLen
            bo_write( oOutHandle, cThisCommand + ;
              ' ' + ;
              ALLTRIM( aLocals[ y ] ) + ;
              cComment + ;
              oBuffObj3[ newline ] )
          NEXT

          lWorkDone := .T.

        ENDIF

      CASE lConvertInc .AND. nLineLen > 8 .AND. ;
          UPPER( aLine[ 1 ] ) == UPPER( aLine[ 5 ] ) .AND. ;
          aLine[ 3 ] $ ':='
        aParts := lineparse( cThisLine )
        aLine  := aParts[ 1 ]
        aType  := aParts[ 2 ]

        nLineLen := LEN( aLine )

        DO CASE
        CASE ldeflate5  //cannot substitute as lineparser deleted positions
          //just don't convert to incrementors with this option on 6/05 PS
          bo_write( oOutHandle, cThisLine + ' ' + cComment + oBuffObj3[ newline ] )
        CASE aLine[ 9 ] == '1' .AND. nLineLen == 9 .AND. aLine[ 7 ] $ '+-'
          bo_write( oOutHandle, aLine[ 1 ] + aLine[ 7 ] + aLine[ 7 ] + ' ' + cComment + oBuffObj3[ newline ] )
          lWorkDone := .T.
        CASE aLine[ 7 ] $ '+-*/^'
          cEndOfLine := ''
          FOR y := 9 TO nLineLen
            cEndOfLine += aLine[ y ]
          NEXT
          bo_write( oOutHandle, aLine[ 1 ] + ' ' + aLine[ 7 ] + '= ' + cEndOfLine + ' ' + cComment + oBuffObj3[ newline ] )
          lWorkDone := .T.
        OTHERWISE
          bo_write( oOutHandle, cThisLine + ' ' + cComment + oBuffObj3[ newline ] )
        ENDCASE

      CASE lConvertDo .AND. nLineLen > 2 .AND. ;
          UPPER( aLine[ 1 ] ) == 'DO' .AND. ;
          ! ( PAD( aLine[ 3 ], 4 ) $ 'CASE|WHIL' )

        cOutput := aLine[ 3 ] + '('

        IF nLineLen > 5 .AND. UPPER( aline[ 5 ] ) == 'WITH'
          FOR y := 6 TO nLineLen
            IF LEFT( aType[ y ], 2 ) $ '//*'
              cComment := aLine[ y ]
              EXIT
            ENDIF
            IF !( LEFT( aLine[ y ], 1 ) $ ', /()' )
              cOutput += '@'
            ENDIF
            cOutput += aLine[ y ]
          NEXT
        ENDIF

        bo_write( oOutHandle, cOutput + ') ' + cComment + oBuffObj3[ newline ] )
        lWorkDone := .T.

      OTHERWISE

        // this line is not a declaration line, write it with no change
        bo_write( oOutHandle, cThisLine + cComment + oBuffObj3[ newline ] )

        // and if it is a continuation, write all the lines that follow
        // the continuation
        DO WHILE RIGHT( ALLTRIM( cThisLine ), 1 ) == ';'

          aParts := stripcomnt( bReadLine( oBuffObj3 ) )
          @  6, 67 SAY STR( bLineNumber( oBuffObj3 ), 8 )
          cThisLIne := aParts[ 1 ]
          cComment  := aParts[ 2 ]

          bo_write( oOutHandle, cThisLine + cComment + oBuffObj3[ newline ] )

        ENDDO

      ENDCASE

    ENDDO   //matching do while line 109

    // we are done with this file, so close the input and output

    bclose( oBuffObj3 )

  ENDIF

ENDIF

bo_close( oOutHandle )

RETURN


*+--------------------------------------------------------------------
*+    STATIC Function stripcomnt()
*+    Called from ( declbust.prg )   3 - procedure declbust()
*+--------------------------------------------------------------------
STATIC FUNCTION stripcomnt( cThisLine )

LOCAL nPointer  := 0
LOCAL nParen    := 0
LOCAL nBrack    := 0
LOCAL nBrace    := 0
LOCAL nSQuote   := 0
LOCAL nDQuote   := 0
LOCAL inlinecmt := 0
LOCAL x
LOCAL nNumChars := LEN( cThisLine )
LOCAL cThisChar
LOCAL cTwoChars
LOCAL cString
LOCAL cComment

IF '//' $ cThisLine .OR. '&&' $ cThisLine

  FOR x := 1 TO nNumChars

    cTwoChars := SUBSTR( cThisLine, x, 2 )

    DO CASE
    CASE cTwoChars == '/*'
      inlinecmt ++
    CASE cTwoChars == '*/'
      inlinecmt --
    ENDCASE

    IF inlinecmt == 0

      cThisChar := SUBSTR( cThisLine, x, 1 )

      IF nSQuote == 0 .AND. nDQuote == 0
        DO CASE
        CASE cThisChar == '('
          nParen ++
        CASE cThisChar == ')'
          nParen --
        CASE cThisChar == '{'
          nBrace ++
        CASE cThisChar == '}'
          nBrace --
        CASE cThisChar == '['
          nBrack ++
        CASE cThisChar == ']'
          nBrack --
        ENDCASE
      ENDIF

      DO CASE
      CASE cThisChar == '"'
        IF nSQuote == 0
          IF nDQuote == 1
            nDQuote := 0
          ELSE
            nDQuote := 1
          ENDIF
        ENDIF
      CASE cThisChar == "'"
        IF nDQuote == 0
          IF nSQuote == 1
            nSQuote := 0
          ELSE
            nSQuote := 1
          ENDIF
        ENDIF
      ENDCASE

      // if all of this is true, then we just found a comment

      IF ( cTwoChars == '&&' .OR. cTwoChars == '//' ) .AND. ;
          nParen + nBrack + nBrace + nSQuote + nDQuote == 0

        nPointer := x
        EXIT

      ENDIF

    ENDIF

  NEXT

ENDIF

IF nPointer > 0
  cString  := LEFT( cThisLine, nPointer - 1 )
  cComment := SUBSTR( cThisLine, nPointer )
ELSE
  cString  := cThisLine
  cComment := ''
ENDIF

RETURN { cString, cComment }

*+--------------------------------------------------------------------
*+    Function tab2space()
*+    Called from ( declbust.prg )   1 - procedure declbust()
*+--------------------------------------------------------------------
FUNCTION tab2space( aString )

RETURN STRTRAN( aString, CHR( K_TAB ), ' ' )

*+--------------------------------------------------------------------
*+    Function nextcomma()
*+    Called from ( declbust.prg )   2 - procedure declbust()
*+--------------------------------------------------------------------
FUNCTION nextcomma( cThisLine )

/*

Realistically, this is the heartbeat of this entire process. Without this
function, it is impossible to determine where a multiple declaration begins
and ends, since Clipper language allows overloading of symbols in the
language. In this case, the comma is overloaded. It means more than
one thing.

Rules:

Anything inside an inline comment is bypassed

Any comma inside a function should be bypassed

Comma, Parenthesis, Braces and Brackets should be bypassed if they are
inside a string declaration.

Single quotes are bypassed if they are inside
a double quote string declaration

Double quotes are bypassed if they are inside
a single quote string declaration

Note:

This routine does not consider [ ] characters to be string declaration.
Although they can legally be used that way, I have not found it to be
common. It also difficult to determine when they are being used in this
manner.

*/

LOCAL nPointer  := 0
LOCAL nParen    := 0
LOCAL nBrack    := 0
LOCAL nBrace    := 0
LOCAL nSQuote   := 0
LOCAL nDQuote   := 0
LOCAL inlinecmt := 0
LOCAL x
LOCAL nNumChars := LEN( cThisLine )
LOCAL cThisChar
LOCAL cTwoChars

IF ',' $ cThisLine

  FOR x := 1 TO nNumChars

    cTwoChars := SUBSTR( cThisLine, x, 2 )

    DO CASE
    CASE cTwoChars == '/*'
      inlinecmt ++
    CASE cTwoChars == '*/'
      inlinecmt --
    ENDCASE

    IF inlinecmt == 0

      cThisChar := SUBSTR( cThisLine, x, 1 )

      IF nSQuote == 0 .AND. nDQuote == 0
        DO CASE
        CASE cThisChar == '('
          nParen ++
        CASE cThisChar == ')'
          nParen --
        CASE cThisChar == '{'
          nBrace ++
        CASE cThisChar == '}'
          nBrace --
        CASE cThisChar == '['
          nBrack ++
        CASE cThisChar == ']'
          nBrack --
        ENDCASE
      ENDIF

      DO CASE
      CASE cThisChar == '"'
        IF nSQuote == 0
          IF nDQuote == 1
            nDQuote := 0
          ELSE
            nDQuote := 1
          ENDIF
        ENDIF
      CASE cThisChar == "'"
        IF nDQuote == 0
          IF nSQuote == 1
            nSQuote := 0
          ELSE
            nSQuote := 1
          ENDIF
        ENDIF
      ENDCASE

      // if all of this is true, then we just found a comma worth dividing on!

      IF cThisChar == ',' .AND. ;
                nParen + nBrack + nBrace + nSQuote + nDQuote == 0

        nPointer := x
        EXIT

      ENDIF

    ENDIF

  NEXT

ENDIF

RETURN nPointer
