*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/functrak.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Procedure init_func_text()
*+               Procedure functrak()
*+               Procedure func_call()
*+               Procedure end_func_text()
*+               Procedure func_text()
*+               STATIC Function findfunc()
*+               STATIC Function SubArrySrch()
*+       Tables: USE (atemp[ii,1])
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include 'fileio.ch'
#define newline  11

STATIC aFuncs     := {}   // List of functions in each module
STATIC aThisSrc   := {}   // Module Name, sub function list
STATIC aFuncList  := {}   // The big collection of how each function gets called
STATIC aTable     := {}   // contains table references for the TABLE.TXT file
STATIC aIndex     := {}   // contains index references for the INDEX.TXT file
STATIC sFuncText  := ''   // contains the function header line
STATIC sModule    := ''   // contains the current module name
STATIC cFullPath  := ''   // contains a reference to the
STATIC aMyLibFunc := {}   // STATIC array of table function names
STATIC aMyIndFunc := {}   // STATIC array of index function names

*+--------------------------------------------------------------------
*+    Procedure init_func_text()
*+    Called from ( click.prg    )   1 - procedure click()
*+       Calls    ( token.prg    )   2 - function numtoken()
*+                ( profile.prg  )   2 - function profilestring()
*+                ( token.prg    )   2 - function numtoken()
*+--------------------------------------------------------------------
PROCEDURE init_func_text( cModule, cClickini )

// called at the beginning of each file

LOCAL cMyLibFunc
LOCAL cMyIndFunc
LOCAL nElems
LOCAL x
IF cFullPath == ''
  cFullPath  := cClickini   //this retains original program logic
  cMyLibFunc := UPPER( ProfileString( cFullPath, 'CLICK', 'MY_TABLE_FUNCTION', '' ) )
  cMyIndFunc := UPPER( ProfileString( cFullPath, 'CLICK', 'MY_INDEX_FUNCTION', '' ) )
  IF !EMPTY( cMyLibFunc )
    nElems := numtoken( cMyLibFunc, '|' )
    ASIZE( aMyLibFunc, nElems )
    FOR x := 1 TO nElems
      aMyLibFunc[ x ] := UPPER( token( cMyLibFunc, '|', x ) )
    NEXT
    // add this to the array
    AADD( aMyLibFunc, 'DBUSEAREA' )
  ENDIF
  IF !EMPTY( cMyIndFunc )
    nElems := numtoken( cMyIndFunc, '|' )
    ASIZE( aMyIndFunc, nElems )
    FOR x := 1 TO nElems
      aMyIndFunc[ x ] := UPPER( token( cMyIndFunc, '|', x ) )
    NEXT
    // add this to the array
    AADD( aMyIndFunc, 'DBCREATEIND' )
  ENDIF
ENDIF

sModule := cModule

RETURN

*+--------------------------------------------------------------------
*+    Procedure functrak()
*+    Called from ( click.prg    )   1 - STATIC function func_head()
*+--------------------------------------------------------------------
PROCEDURE functrak( cFuncText )

// Called as each function header is created

sFuncText := cFuncText

IF EMPTY( aThisSrc )
  aThisSrc := { sModule, {} }
ENDIF

AADD( aThisSrc[ 2 ], sFuncText )

RETURN

*+--------------------------------------------------------------------
*+    Procedure func_call()
*+    Called from ( click.prg    )   1 - procedure click()
*+       Calls    ( functrak.prg )   2 - STATIC function subarrysrch()
*+--------------------------------------------------------------------
PROCEDURE func_call( aLine, aType )

// called as each line is parsed.

LOCAL x
LOCAL nHowmany  := LEN( aType )
LOCAL nPointer
LOCAL nPointer2
LOCAL uFW       := UPPER( aLine[ 1 ] )
LOCAL cLine     := ''

FOR x := 1 TO nHowMany  //3/06 added P type 'do procedure' & 'set key proc' removed 2/09
  //causing problem with 'to' proc/func in set key lines
  IF aType[ x ] == 'F'  // .or. aType[x] == 'P'  //to be add to the afunclist array
    //this is good place of trapping unusual function entries altd()
    nPointer := ASCAN( aFuncList, { | y | UPPER( y[ 1 ] ) == UPPER( aLine[ x ] ) } )
    IF EMPTY( nPointer )
      AADD( afunclist, { aLine[ x ], { { sFuncText, sModule, 1 } } } )
    ELSE
      IF ( nPointer2 := ASCAN( aFuncList[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .AND. y[ 2 ] == sModule } ) ) == 0
        AADD( afunclist[ nPointer, 2 ], { sFuncText, sModule, 1 } )
      ELSE
        aFuncList[ nPointer, 2, nPointer2, 3 ] ++
      ENDIF
    ENDIF
  ENDIF
NEXT

// this collects TABLE and INDEX information

DO CASE
CASE uFW == 'USE' .OR. SubArrySrch( aMyLibFunc, aLine )

  FOR x := 1 TO nHowMany
    cLine += aLine[ x ]
  NEXT

  nPointer := ASCAN( aTable, { | y | y[ 1 ] == sModule } )

  IF EMPTY( nPointer )
    AADD( aTable, { sModule, { { sFuncText, cLine, 1 } } } )
  ELSE
    IF ( nPointer2 := ASCAN( aTable[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .AND. UPPER( y[ 2 ] ) == UPPER( cLine ) } ) ) == 0
      AADD( aTable[ nPointer, 2 ], { sFuncText, cLine, 1 } )
    ELSE
      aTable[ nPointer, 2, nPointer2, 3 ] ++
    ENDIF
  ENDIF

CASE uFW == 'INDEX' .OR. SubArrySrch( aMyIndFunc, aLine )

  FOR x := 1 TO nHowMany
    cLine += aLine[ x ]
  NEXT

  nPointer := ASCAN( aIndex, { | y | y[ 1 ] == sModule } )

  IF EMPTY( nPointer )
    AADD( aIndex, { sModule, { { sFuncText, cLine, 1 } } } )
  ELSE
    IF ( nPointer2 := ASCAN( aIndex[ nPointer, 2 ], { | y | y[ 1 ] == sFuncText .AND. UPPER( y[ 2 ] ) == UPPER( cLine ) } ) ) == 0
      AADD( aIndex[ nPointer, 2 ], { sFuncText, cLine, 1 } )
    ELSE
      aIndex[ nPointer, 2, nPointer2, 3 ] ++
    ENDIF
  ENDIF

ENDCASE

RETURN

*+--------------------------------------------------------------------
*+    Procedure end_func_text()
*+    Called from ( click.prg    )   1 - procedure click()
*+--------------------------------------------------------------------
PROCEDURE end_func_text()

// called at the end of each file

IF !EMPTY( aThisSrc )
  AADD( aFuncs, aThisSrc )
  aThisSrc := {}
ENDIF

RETURN

*+--------------------------------------------------------------------
*+    Procedure func_text()
*+    Called from ( click.prg    )   1 - procedure click()
*+       Calls    ( prb_ampm.prg )   4 - function am_pm()
*+                ( obufread.prg )   1 - function bclose()
*+                ( obufread.prg )   1 - function beof()
*+                ( obufread.prg )   1 - function binit()
*+                ( obufread.prg )   1 - function bopen()
*+                ( obufwrit.prg )   5 - procedure bo_close()
*+                ( obufwrit.prg )   5 - function bo_init()
*+                ( obufwrit.prg )   5 - function bo_open()
*+                ( obufwrit.prg )  57 - procedure bo_write()
*+                ( obufread.prg )   1 - function breadline()
*+                ( obufread.prg )   1 - function brelative()
*+                ( click.prg    )   5 - procedure centertext()
*+                ( unresolved   )   1 - function dbfsize()
*+                ( filnpath.prg )   1 - function fileinpath()
*+                ( functrak.prg )   1 - STATIC function findfunc()
*+                ( nicedate.prg )   4 - function nicedate()
*+                ( profile.prg  )  11 - function profilestring()
*+                ( click.prg    )   5 - procedure show_in()
*+                ( click.prg    )  12 - procedure show_out()
*+--------------------------------------------------------------------
PROCEDURE func_text( aLibList, aFileList, cClickini )

// called after all files have been processed

// Pass 4, with the purple progress meter.

LOCAL cSrcOut   := ProfileString( cClickini, 'CLICK', 'SOURCE_XREF_FILE', 'SRC_CROS.TXT' )
LOCAL cFncOut   := ProfileString( cClickini, 'CLICK', 'FUNCTION_XREF_FILE', 'FNC_CROS.TXT' )
LOCAL cTblOut   := ProfileString( cClickini, 'CLICK', 'TABLE_XREF_FILE', 'TBL_CROS.TXT' )
LOCAL cFldOut   := ProfileString( cClickini, 'CLICK', 'FIELD_XREF_FILE', 'FLD_CROS.TXT' )
LOCAL lSrcAdd   := ProfileString( cClickini, 'CLICK', 'FUNCTION_REF_INTO_SOURCE', 'YES' ) == 'YES'
LOCAL lFncAdd   := ProfileString( cClickini, 'CLICK', 'FUNCTION_XREF_INTO_SOURCE', 'YES' ) == 'YES'
LOCAL lTblAdd   := ProfileString( cClickini, 'CLICK', 'TABLE_XREF_INTO_SOURCE', 'YES' ) == 'YES'
LOCAL lIndAdd   := ProfileString( cClickini, 'CLICK', 'INDEX_XREF_INTO_SOURCE', 'YES' ) == 'YES'
LOCAL lTimeDate := ProfileString( cClickini, 'CLICK', 'RETAIN_ORIGINAL_TIME_DATE_ON_OUTPUT_FILES', 'YES' ) == 'YES'
LOCAL cHeadDiv  := ProfileString( cClickini, 'CLICK', 'HEAD_DIV', '' )

LOCAL bo_Handle
LOCAL bi_Handle
//this OSCRLF used for cross reference .txt files
//while prg files retain the eol of original input file 10/03
LOCAL OSCRLF  //   := HB_OSNewLine()
LOCAL cOutput, cOutDir, cFullPath, ii, jj, kk   //cThisOut,ctest,nW 2/09
LOCAL v, w, x, y, z, cFoundIn, nV, nX, nY, cThisProg, cLastProg, cProg, dirsep, drivesep
LOCAL cThisFile, cOutFile, lGotHeader, cThisLine, cThisFunc, spat, nOldPcntDone, cProcFunc
LOCAL nPcntDone  := 0, ntemp
LOCAL lStatic, lFoundOne := .F.
LOCAL lNoLibList := EMPTY( aLibList )
LOCAL lGotIt, cLookFor, lstarttrap := .F.
LOCAL aLib       := {}
LOCAL aHit       := {}
LOCAL nPointer, nPointer1, nPointer2, nMinPntr
LOCAL aF2F       := {}
LOCAL aTemp      := {}, afld_list := {}, ctemp, cdatatype
LOCAL sp         := SPACE( 6 )
OSCRLF := HB_OSNEWLINE()
IF CHR( 13 ) $ OSCRLF
  dirsep   := '\'
  drivesep := DISKNAME() + ':'  //? windows version
ELSE  //must be linux
  dirsep   := '/'
  drivesep := ''
ENDIF
cFullPath := drivesep + dirsep + CURDIR( drivesep ) + dirsep  //10/03 local copy in startup directory
cOutDir   := cFullPath + ProfileString( cClickini, 'CLICK', 'OUTPUT_DIRECTORY', 'clickout' ) + dirsep
IF lSrcAdd .OR. lFncAdd .OR. lTblAdd .OR. lIndAdd

  nV := LEN( aFilelist )
  FOR v := 1 TO nV  //loop thru each file in list
    cThisFile := cOutDir + aFileList[ v ]
    show_out( cThisFile )
    cOutFile := cOutDir + '$tempfil.$$$'
    @  4,  1 clear TO 4, MAXCOL() - 1
    centertext( 'Current File => ' + cThisFile, 4 )
    @  6, 11 clear TO 6, MAXCOL() - 5
    @  6, 10 SAY '4'
    // initialize buffered input first to get newline character
    bi_handle := binit( cThisFile )
    bOpen( bi_handle )  //must open file and get correct newline
    bo_handle := bo_init( cOutFile, FO_WRITE, bi_handle[ newline ], cClickini )
    bo_Open( bo_handle )
    lGotHeader   := .F.   //will need a new file header
    nOldPcntDone := 0
    DO WHILE !beof( bi_handle )   //on same file, get another line
      nOldPcntDone := nPcntDone
      nPcntDone    := INT( bRelative( bi_handle ) * 50 )
      IF nOldPcntDone <> nPcntDone
        @  6, 15 SAY REPLICATE( '', nPcntDone ) COLOR 'RB+/B'
      ENDIF
      cThisLine := bReadLine( bi_handle )
      IF LEFT( cThisLine, 2 ) == '*+'

        DO CASE
          //this case happens once per file
        CASE LEFT( cThisLine, 27 ) == '*+    Reformatted by Click!'
          //This insert functions & procedures contained within this file
          lGotHeader := .T.
          IF lSrcAdd
            w := ASCAN( aFuncs, { | x | x[ 1 ] == aFileList[ v ] } )
            IF w > 0
              nY := LEN( aFuncs[ w, 2 ] )
              IF nY > 0
                FOR y := 1 TO nY
                  IF y == 1
                    bo_write( bo_handle, '*+    Functions: ' + aFuncs[ w, 2, y ] + bi_handle[ newline ] )
                  ELSE
                    bo_write( bo_handle, '*+               ' + aFuncs[ w, 2, y ] + bi_handle[ newline ] )
                  ENDIF
                NEXT
                bo_write( bo_handle, '*+' + bi_handle[ newline ] )
              ENDIF
            ENDIF
          ENDIF
          // This inserts table data into the FILE HEADER.
          IF lTblAdd
            IF ( nPointer := ASCAN( aTable, { | x | x[ 1 ] == aFileList[ v ] } ) ) > 0
              nY := LEN( aTable[ nPointer, 2 ] )
              IF lTblAdd .AND. nY > 0
                FOR y := 1 TO nY
                  IF y == 1
                    bo_write( bo_handle, '*+       Tables: ' + aTable[ nPointer, 2, y, 2 ] + bi_handle[ newline ] )
                  ELSE
                    bo_write( bo_handle, '*+               ' + aTable[ nPointer, 2, y, 2 ] + bi_handle[ newline ] )
                  ENDIF
                NEXT
                bo_write( bo_handle, '*+' + bi_handle[ newline ] )
              ENDIF
            ENDIF
          ENDIF
          // This inserts index data into the FILE HEADER.
          IF lIndAdd
            IF ( nPointer := ASCAN( aIndex, { | x | x[ 1 ] == aFileList[ v ] } ) ) > 0
              nY := LEN( aIndex[ nPointer, 2 ] )
              IF lTblAdd .AND. nY > 0
                FOR y := 1 TO nY
                  IF y == 1
                    bo_write( bo_handle, '*+      Indexes: ' + aIndex[ nPointer, 2, y, 2 ] + bi_handle[ newline ] )
                  ELSE
                    bo_write( bo_handle, '*+               ' + aIndex[ nPointer, 2, y, 2 ] + bi_handle[ newline ] )
                  ENDIF
                NEXT
                bo_write( bo_handle, '*+' + bi_handle[ newline ] )
              ENDIF
            ENDIF
          ENDIF
          //no more writing until we get to next header
          bo_write( bo_handle, cThisLine + bi_handle[ newline ] )
          //following case happens once per procedure/function
        CASE lFncAdd .AND. lGotHeader .AND. LEFT( cThisLine, 6 ) == '*+    '
          //should only get here needing functions in a proc/func header
          // This inserts function data into the FUNCTION HEADERS
          cProcFunc := ALLTRIM( SUBSTR( cThisLine, 3 ) )
          cThisFunc := UPPER( SUBSTR( cThisLine, 7 ) )
          lStatic   := UPPER( LEFT( cThisFunc, 4 ) ) == 'STAT'
          spat      := RAT( ' ', cThisFunc )
          cThisFunc := SUBSTR( cThisFunc, spat + 1 )
          cThisFunc := LEFT( cThisFunc, LEN( cThisFunc ) - 2 )
          x         := ASCAN( aFuncList, { | x | UPPER( x[ 1 ] ) == cThisFunc } )
          bo_write( bo_handle, cThisLine + bi_handle[ newline ] )
          bo_write( bo_handle, '*+' + bi_handle[ newline ] )

          IF x > 0  //are there any called by in aFuncList
            nY        := LEN( aFuncList[ x, 2 ] )
            cLastProg := '________'
            z         := 0
            FOR y := 1 TO nY  //print the entire called by list
              IF lStatic  // is the function STATIC?

                // Here, we are scoping the search. If this is
                // a STATIC function, then there could be several
                // of the function by the same name, so this
                // routine figures out if the function is STATIC
                // and then eliminates impossible calls from other
                // modules.

                // if these match, then the call belongs to this
                // STATIC function in this module
                IF aFileList[ v ] == aFuncList[ x, 2, y, 2 ]
                  cThisProg := ' ( ' + ;
                    PAD( LOWER( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
                    ' ) '

                  IF cThisProg <> cLastProg
                    cProg := cThisProg
                  ELSE
                    cProg := SPACE( 18 )
                  ENDIF
                  cOutput := IF( ++ z == 1, 'Called from', SPACE( 11 ) ) + ;
                    cProg + ;
                    STR( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
                    LOWER( aFuncList[ x, 2, y, 1 ] )
                  cLastProg := cThisProg
                  show_out( cOutput )
                  bo_write( bo_handle, '*+    ' + cOutput + bi_handle[ newline ] )
                ENDIF

              ELSE  //not lStatic

                // So if we are here, the function was not STATIC.
                // include ALL calls.

                cThisProg := ' ( ' + ;
                  PAD( LOWER( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
                  ' ) '

                IF cThisProg <> cLastProg
                  cProg := cThisProg
                ELSE
                  cProg := SPACE( 18 )
                ENDIF
                cOutput := IF( y == 1, 'Called from', SPACE( 11 ) ) + ;
                  cProg + ;
                  STR( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
                  LOWER( aFuncList[ x, 2, y, 1 ] )
                cLastProg := cThisProg
                show_out( cOutput )
                bo_write( bo_handle, '*+    ' + cOutput + bi_handle[ newline ] )
              ENDIF   //finished whether lStatic T/Ft
            NEXT  //done with the called by list
            bo_write( bo_handle, '*+' + bi_handle[ newline ] )
          ENDIF   //were there any called by candidates, x>0
          //finished with called from function/procedures
          //now add functions/prg called by this prg added 3/06
          //kind of a reverse funclist array lookup
          //afilelist[v] = list of all prg files
          atemp := {}   //empty array
          FOR ii := 1 TO LEN( afunclist )   //step thru all the proc/func identified
            FOR jj := 1 TO LEN( afunclist[ ii, 2 ] )  //step throu all the called from functions
              //if file we are on=called from file .and. procedure/function we are on
              //matches called from function add it to the list
              IF UPPER( afilelist[ v ] ) == UPPER( afunclist[ ii, 2, jj, 2 ] ) .AND. ;
                       UPPER( cProcFunc ) == UPPER( afunclist[ ii, 2, jj, 1 ] )
                AADD( atemp, { afunclist[ ii, 1 ] + '()', STR( aFuncList[ ii, 2, jj, 3 ], 3 ) + ' - ' } )
              ENDIF
            NEXT  //jj
          NEXT  //ii
          //arrange them so they print alphabetically
          atemp := ASORT( atemp,,, { | x, y | UPPER( x[ 1 ] ) < UPPER( y[ 1 ] ) } )   //sort list
          FOR ii := 1 TO LEN( atemp )
            atemp[ ii ] := atemp[ ii, 2 ] + atemp[ ii, 1 ]  //combine back to one dimension
          NEXT
          FOR ii := 1 TO LEN( atemp )   //update all the references with
            FOR jj := 1 TO LEN( afuncs )  //step thru all prg files
              FOR kk := 1 TO LEN( afuncs[ jj, 2 ] )   //step thru all functions in the file
                IF UPPER( SUBSTR( atemp[ ii ], 7 ) ) $ UPPER( afuncs[ jj, 2, kk ] )
                  DO CASE   //a STATIC test
                  CASE UPPER( afuncs[ jj, 1 ] ) = UPPER( afilelist[ v ] ) .AND. ;
                      'STAT' = UPPER( SUBSTR( afuncs[ jj, 2, kk ], 1, 4 ) )   //best we can do
                    atemp[ ii ] := '  ( ' + PAD( afuncs[ jj, 1 ], 12 ) + ' ) ' + ;
                      SUBSTR( atemp[ ii ], 1, 6 ) + LOWER( afuncs[ jj, 2, kk ] )
                    kk := LEN( afuncs[ jj, 2 ] )  //stop the search
                  CASE 'STAT' = UPPER( SUBSTR( afuncs[ jj, 2, kk ], 1, 4 ) )
                    //out of scope don't enter anything
                  OTHERWISE
                    atemp[ ii ] := '  ( ' + PAD( afuncs[ jj, 1 ], 12 ) + ' ) ' + ;
                      SUBSTR( atemp[ ii ], 1, 6 ) + LOWER( afuncs[ jj, 2, kk ] )
                    //continue in case we find a STATIC match
                  ENDCASE
                ENDIF
              NEXT
            NEXT
            IF SUBSTR( atemp[ ii ], 1, 4 ) != '  ( ' .AND. ii <= LEN( atemp )
              //we didn't find the function in a *.prg file, mark unresolved function
              atemp[ ii ] := '  ( ' + PAD( 'unresolved', 12 ) + ' ) ' + ;
                SUBSTR( atemp[ ii ], 1, 6 ) + 'function ' + SUBSTR( atemp[ ii ], 7 )
            ENDIF
          NEXT
          IF LEN( atemp ) > 0   //were there any "Calls to" found
            //sort the array before writing the handle
            FOR ii := 1 TO LEN( atemp )   //now print the calls to stuff out
              cOutput := IF( ii == 1, '   Calls  ', SPACE( 10 ) ) + ;
                atemp[ ii ]
              show_out( cOutput )
              bo_write( bo_handle, '*+    ' + cOutput + bi_handle[ newline ] )
            NEXT
          ENDIF   //len(atemp)>0
          bo_write( bo_handle, '*+' + bi_handle[ newline ] )
        OTHERWISE
          bo_write( bo_handle, cThisLine + bi_handle[ newline ] )
          bo_write( bo_handle, '*+' + bi_handle[ newline ] )
        ENDCASE   //get header first the function calls
      ELSE  //nothing special just write the line
        bo_write( bo_handle, cThisLine + bi_handle[ newline ] )
      ENDIF   //left( cThisLine, 2 ) == '*+'
    ENDDO   //while not end-of-file
    bclose( bi_handle )
    bo_close( bo_handle )

    //removed 10/03, not sure how to do this, or if it's still a good idea
    //      if lTimeDate  // From CLICK.INI sets time/date to original file
    //         setfdati( cOutFile, filedate( cThisFile ), filetime( cThisFile ) )
    //      endif

    FERASE( cThisFile )   //temporarily out debugging altd
    FRENAME( cOutFile, cThisFile )

  NEXT  //for next file in file list line~291
ENDIF   //done putting info into source files

@  4,  1 clear TO 7, MAXCOL() - 1

IF !EMPTY( cSrcOut )

  // This creates the text file in the output directory which contains
  // the entire function reference for every module.
  // It dumps the multidimensional array to a text file in a pretty format.

  centertext( 'Current File => ' + cOutDir + cSrcOut, 4 )
  FERASE( cOutDir + cSrcOut )
  bo_Handle := bo_init( cOutDir + cSrcOut, FO_WRITE, OSCRLF, cClickini )  //this will pickup OS newline
  bo_open( bo_Handle )

  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( DATE() ) + ' at ' + am_pm( TIME() ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF + OSCRLF )

  show_out( 'Sorting Master Function List' )
  aFuncs := ASORT( aFuncs,,, { | x, y | UPPER( x[ 1 ] ) < UPPER( y[ 1 ] ) } )

  show_out( 'Sorting Sub Function List' )
  nX := LEN( aFuncs )
  FOR x := 1 TO nX
    show_out( aFuncs[ x, 1 ] )
    bo_write( bo_handle, aFuncs[ x, 1 ] + OSCRLF + OSCRLF )
    AEVAL( aFuncs[ x, 2 ], { | x | bo_write( bo_handle, '  ' + x + OSCRLF ) } )
    bo_write( bo_handle, OSCRLF )
  NEXT
  bo_close( bo_handle )
ENDIF   //done outputting function reference for modules

IF !EMPTY( cFncOut )

  // This creates the text file in the output directory which contains
  // the function to function reference for every module.

  // It dumps the multidimensional array to a text file in a pretty format.

  @  4,  1 clear TO 4, MAXCOL() - 1
  centertext( 'Current File => ' + cOutDir + cFncOut, 4 )

  FERASE( cOutDir + cFncOut )
  bo_Handle := bo_init( cOutDir + cFncOut, FO_WRITE, OSCRLF, cClickini )
  bo_open( bo_Handle )

  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( DATE() ) + ' at ' + am_pm( TIME() ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF )

  show_out( 'Sorting Called Function List' )
  aFuncList := ASORT( aFuncList,,, { | x, y | UPPER( x[ 1 ] ) < UPPER( y[ 1 ] ) } )

  nX := LEN( aFuncList )
  FOR x := 1 TO nX
    cLookFor := LOWER( aFunclist[ x, 1 ] )
    IF cLookFor == 'if'
      LOOP
    ENDIF
    cOutput  := PAD( cLookFor + '()', 15 )
    cFoundIn := findfunc( ' ' + aFunclist[ x, 1 ] + '()' )
    cLookFor += ' '
    IF EMPTY( cFoundIn )
      // Not found in the internal function array
      lGotIt := .F.
      // is it in the CLICK.DBF?
      IF click->( DBSEEK( cLookFor ) )
        // if we weren't passed a .LNK file, we have no LIB list
        IF lNoLibList
          // show them all
          DO WHILE cLookFor $ click->fnct
            IF LEN( cOutPut ) == 15
              cOutput += ' in ' + TRIM( click->srce ) + OSCRLF
            ELSE
              cOutput += SPACE( 15 ) + ' or ' + TRIM( click->srce ) + OSCRLF
            ENDIF
            show_in( SPACE( 19 ) + click->srce )
            lGotIt := .T.
            click->( DBSKIP( 1 ) )
          ENDDO
        ELSE
          // aha! we do have a lib list

          // first, find all the matches in the lib list.

          aLib     := {}
          aHit     := {}
          nMinPntr := 9999999999
          DO WHILE cLookFor $ click->fnct
            IF ( nPointer := ASCAN( aLibList, { | aParm | aParm $ TRIM( click->srce ) } ) ) > 0
              AADD( aHit, nPointer )
              AADD( aLib, aLibList[ nPointer ] )
              nMinPntr := MIN( nMinPntr, nPointer )
            ENDIF
            click->( DBSKIP( 1 ) )
          ENDDO

          // then, figure out which one is the first one in the current path.

          IF LEN( aHit ) > 0
            nPointer := ASCAN( aHit, nMinPntr )
            cOutput  += ' in ' + fileinpath( aLib[ nPointer ], 'LIB' ) + OSCRLF
            show_in( SPACE( 19 ) + aLib[ nPointer ] )
            lGotIt := .T.
          ENDIF

        ENDIF
      ENDIF

      // never found a match???

      IF !lGotIt
        cOutput += ' <unresolved function>'
        show_in( cOutput )
        cOutput += OSCRLF
      ENDIF

    ELSE
      cOutput += ' in ' + LOWER( cFoundIn )
      show_in( cOutput )
      cOutput += OSCRLF
    ENDIF

    bo_write( bo_Handle, OSCRLF + cOutput + OSCRLF )
    cLastProg := '________'

    aFuncList[ x, 2 ] := ASORT( aFuncList[ x, 2 ],,, { | x, y | UPPER( x[ 2 ] + x[ 1 ] ) < UPPER( y[ 2 ] + y[ 1 ] ) } )
    nY                := LEN( aFuncList[ x, 2 ] )
    FOR y := 1 TO nY
      cThisProg := ' ( ' + ;
        PAD( LOWER( aFuncList[ x, 2, y, 2 ] ), 12 ) + ;
        ' ) '

      IF cThisProg <> cLastProg
        cProg := cThisProg
      ELSE
        cProg := SPACE( 18 )
      ENDIF
      cOutput := IF( y == 1, '  Called from', SPACE( 13 ) ) + ;
        cProg + ;
        STR( aFuncList[ x, 2, y, 3 ], 3 ) + ' - ' + ;
        LOWER( aFuncList[ x, 2, y, 1 ] )

      cLastProg := cThisProg
      show_out( cOutput )
      bo_write( bo_handle, cOutput + OSCRLF )
    NEXT
  NEXT
  bo_close( bo_Handle )
ENDIF   //output function information

IF !EMPTY( cTblOut )

  centertext( 'Current File => ' + cOutDir + cTblOut, 4 )

  FERASE( cOutDir + cTBLOut )
  bo_Handle := bo_init( cOutDir + cTblOut, FO_WRITE, OSCRLF, cClickini )
  bo_open( bo_Handle )

  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( DATE() ) + ' at ' + am_pm( TIME() ) + OSCRLF )
  bo_write( bo_handle, '*+' + OSCRLF )
  bo_write( bo_handle, '*+' + REPLICATE( cHeadDiv, 68 ) + OSCRLF )
  bo_write( bo_handle, OSCRLF )

  FOR v := 1 TO nV

    nPointer1 := ASCAN( aTable, { | x | x[ 1 ] == aFileList[ v ] } )
    nPointer2 := ASCAN( aIndex, { | x | x[ 1 ] == aFileList[ v ] } )

    IF nPointer1 > 0 .OR. nPointer2 > 0

      bo_write( bo_handle, aFileList[ v ] + OSCRLF + OSCRLF )
      show_in( aFileList[ v ] )

      IF nPointer1 > 0
        nY := LEN( aTable[ nPointer1, 2 ] )
        IF nY > 0
          FOR y := 1 TO nY
            IF y == 1
              bo_write( bo_handle, '   Tables: ' + aTable[ nPointer1, 2, y, 2 ] + OSCRLF )
            ELSE
              bo_write( bo_handle, '           ' + aTable[ nPointer1, 2, y, 2 ] + OSCRLF )
            ENDIF
            show_out( aTable[ nPointer1, 2, y, 2 ] )
          NEXT
          bo_write( bo_handle, OSCRLF )
        ENDIF
      ENDIF

      IF nPointer2 > 0
        nY := LEN( aIndex[ nPointer2, 2 ] )
        IF lTblAdd .AND. nY > 0
          FOR y := 1 TO nY
            IF y == 1
              bo_write( bo_handle, '  Indexes: ' + aIndex[ nPointer2, 2, y, 2 ] + OSCRLF )
            ELSE
              bo_write( bo_handle, '           ' + aIndex[ nPointer2, 2, y, 2 ] + OSCRLF )
            ENDIF
            show_out( aIndex[ nPointer2, 2, y, 2 ] )
          NEXT
          bo_write( bo_handle, OSCRLF )
        ENDIF
      ENDIF

    ENDIF

  NEXT

  bo_close( bo_Handle )

ENDIF   //output table/index information

IF !EMPTY( cFldOut )

  centertext( 'Current File => ' + cOutDir + cFldOut, 4 )

  FERASE( cOutDir + cFldOut )
  bo_Handle := bo_init( cOutDir + cFldOut, FO_WRITE, OSCRLF, cClickini )
  bo_open( bo_Handle )

  bo_write( bo_handle, '*+  File:' + cOutDir + cFldOut + OSCRLF )
  bo_write( bo_handle, '*+    Created by Click! on ' + nicedate( DATE() ) + ' at ' + am_pm( TIME() ) + OSCRLF )
  bo_write( bo_handle, '*+' + REPLICATE( '-', 75 ) + OSCRLF )
  bo_write( bo_handle, OSCRLF )
  atemp := {}
  atemp := DIRECTORY( '*.dbf' )
  IF LEN( atemp ) = 0
    atemp := DIRECTORY( '*.DBF' )
  ENDI
  ASORT( atemp,,, { | x, y | UPPER( x[ 1 ] ) < UPPER( y[ 1 ] ) } )
  ntemp := ASCAN( atemp, { | x | UPPER( x[ 1 ] ) == 'CLICK.DBF' },, )
  IF ntemp != 0   //don't need the click.dbf one
    ADEL( atemp, ntemp )
    ASIZE( atemp, LEN( atemp ) - 1 )
  ENDIF
  FOR ii := 1 TO LEN( atemp )
    USE (atemp[ii,1])
    afld_list := DBSTRUCT()
    bo_write( bo_handle, OSCRLF + PAD( '  DATABASE: ' + atemp[ ii, 1 ], 25 ) + '  Printed On:' + DTOC( DATE() ) + OSCRLF )
    bo_write( bo_handle, PAD( '  Record Count: ' + LTRIM( STR( LASTREC() ) ), 22 ) + ;
      PAD( 'Table Size: ' + LTRIM( TRANSFORM( dbfsize(), '999,999,999,999' ) ) + ;
      '  ', 57 ) + OSCRLF + OSCRLF )  //pwidth-22=79-22=57
    bo_write( bo_handle, 'Position (.dbf)       Field Name        Type          Width      Dec.' + OSCRLF )
    atemp[ ii, 1 ] = ' (' + SUBSTR( atemp[ ii, 1 ], 1, AT( '.', atemp[ ii, 1 ] ) - 1 ) + '->)'  //drop the .dbf
    FOR X := 1 TO FCOUNT()
      DO CASE
      CASE afld_list[ x, 2 ] == 'C'
        cdatatype := 'Character'
      CASE afld_list[ x, 2 ] == 'N'
        cdatatype := 'Numeric  '
      CASE afld_list[ x, 2 ] == 'L'
        cdatatype := 'Logical  '
      CASE afld_list[ x, 2 ] == 'M'
        cdatatype := 'Memo     '
      CASE afld_list[ x, 2 ] == 'D'
        cdatatype := 'Date     '
      OTHERWISE
        cdatatype := afld_list[ x, 2 ]
      ENDCASE
      IF afld_list[ x, 4 ] == 0
        ctemp := ''   //SPACE(4)
      ELSE
        ctemp := STR( afld_list[ x, 4 ], 4 )
      ENDIF

      show_out( STR( afld_list[ x, 4 ], 4 ) )
      bo_write( bo_handle, PAD( STR( X, 4 ) + atemp[ ii, 1 ], 17 ) + sp + ;
        PAD( afld_list[ x, 1 ], 10 ) + sp + cdatatype + sp + ;
        STR( afld_list[ x, 3 ], 4 ) + sp + ctemp + OSCRLF )

    NEXT
    bo_write( bo_handle, '*+' + REPLICATE( '-', 75 ) + OSCRLF )   //end of fields marker

  NEXT

  bo_close( bo_Handle )

ENDIF   //output some database field information

@  4,  1 clear TO 4, MAXCOL() - 1
@  6,  1 clear TO 6, MAXCOL() - 1

RETURN  //eof func_text

*+--------------------------------------------------------------------
*+    STATIC Function findfunc()
*+    Called from ( functrak.prg )   1 - procedure func_text()
*+--------------------------------------------------------------------
STATIC FUNCTION findfunc( cThisFunc )

LOCAL x
LOCAL nX
LOCAL y
LOCAL nY
LOCAL lRetVal  := ''
LOCAL nFuncLen
LOCAL cLookIn

// This function finds a function reference in the master array.

cThisFunc := UPPER( cThisFunc )
nFuncLen  := LEN( cThisFunc ) + 2

nX := LEN( aFuncs )
FOR x := 1 TO nX
  nY := LEN( aFuncs[ x, 2 ] )
  FOR y := 1 TO nY
    cLookIn := RIGHT( UPPER( aFuncs[ x, 2, y ] ), nFuncLen )
    IF cThisFunc $ cLookIn
      lRetVal := aFuncs[ x, 1 ]
    ENDIF
  NEXT
NEXT

RETURN lRetVal

*+--------------------------------------------------------------------
*+    STATIC Function SubArrySrch()
*+    Called from ( functrak.prg )   2 - procedure func_call()
*+--------------------------------------------------------------------
STATIC FUNCTION SubArrySrch( aFuncs, aLine )

LOCAL x
LOCAL y
LOCAL lRetVal := .F.

BEGIN SEQUENCE
  FOR y := 1 TO LEN( aLine )
    FOR x := 1 TO LEN( aFuncs )
      IF aFuncs[ x ] == UPPER( aLine[ y ] )
        lRetVal := .T.
        BREAK
      ENDIF
    NEXT
  NEXT
END SEQUENCE

RETURN lRetVal

*+ EOF: functrak.prg
