*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/julian.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function TD2JUL()
*+               Function JUL2TIME()
*+               Function JUL2DATE()
*+               Function DIFF2JUL()
*+               Function JUL_DIFF()
*+               Function JUL_BTW()
*+               Function JUL_BTWX()
*+               Function JUL_SEEK()
*+               Function JUL_AVE()
*+               Function TTOS()
*+               Function TTOMS()
*+               Function TTOM()
*+               Function MINS2HUND()
*+               Function PRB_INT()
*+               Function JUL_PACK()
*+               Function JUL_UNPACK()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include "common.ch"

#define BASE_DATE "1980"

*+--------------------------------------------------------------------
*+    Function TD2JUL()
*+    Called from ( click.prg    )   4 - procedure click()
*+       Calls    ( julian.prg   )   1 - function prb_int()
*+                ( julian.prg   )   1 - function ttos()
*+--------------------------------------------------------------------
FUNCTION TD2JUL( cTime, dDate )

DEFAULT cTime TO TIME()
DEFAULT dDate TO DATE()

RETURN dDate - CTOD( '01/01/' + BASE_DATE ) + ;
  ( PRB_INT( TTOS( cTime ) / 100000,, 5 ) )

*+--------------------------------------------------------------------
*+    Function JUL2TIME()
*+       Calls    ( julian.prg   )   2 - function prb_int()
*+--------------------------------------------------------------------
FUNCTION JUL2TIME( Jul1 )

LOCAL nTotSecs := VAL( RIGHT( STR( Jul1, 14, 5 ), 5 ) )
LOCAL H
LOCAL M
LOCAL S

H        := PRB_INT( nTotSecs / 3600 )
nTotSecs := nTotSecs % 3600
M        := PRB_INT( nTotSecs / 60 )
S        := nTotSecs % 60

RETURN STRZERO( H, 2 ) + ':' + ;
  STRZERO( M, 2 ) + ':' + ;
  STRZERO( S, 2 )

*+--------------------------------------------------------------------
*+    Function JUL2DATE()
*+       Calls    ( julian.prg   )   1 - function prb_int()
*+--------------------------------------------------------------------
FUNCTION JUL2DATE( Jul1 )

RETURN CTOD( '01/01/' + BASE_DATE ) + PRB_INT( Jul1 )

*+--------------------------------------------------------------------
*+    Function DIFF2JUL()
*+    Called from ( click.prg    )   1 - procedure click()
*+                ( julian.prg   )   2 - function jul_seek()
*+                                   1 - function jul_ave()
*+       Calls    ( julian.prg   )   8 - function prb_int()
*+--------------------------------------------------------------------
FUNCTION DIFF2JUL( Jul1, Jul2 )

LOCAL M
LOCAL S
LOCAL H
LOCAL retval

LOCAL J1 := MIN( Jul1, Jul2 )
LOCAL J2 := MAX( Jul1, Jul2 )
LOCAL D  := PRB_INT( J2 ) - PRB_INT( J1 )

LOCAL nTotSecs := VAL( RIGHT( STR( J2, 14, 5 ), 5 ) ) - ;
  VAL( RIGHT( STR( J1, 14, 5 ), 5 ) )

D        -= PRB_INT( ABS( nTotSecs ) / 86400 ) + 1
nTotSecs := PRB_INT( nTotSecs % 86400 ) + 86400

H        := PRB_INT( nTotSecs / 3600 ) + ( D * 24 )
nTotSecs := PRB_INT( nTotSecs % 3600 )
M        := PRB_INT( nTotSecs / 60 )
S        := PRB_INT( nTotSecs % 60 )

IF S > 59
  M ++
  S := 0
  IF M > 59
    H ++
    M := 0
  ENDIF
ENDIF

DO CASE
CASE h > 0
  retval := STRZERO( H, 7 ) + ':' + ;
    STRZERO( M, 2 ) + ':' + ;
    STRZERO( S, 2 )
CASE m > 0
  retval := STRZERO( M, 2 ) + ':' + ;
    STRZERO( S, 2 )
OTHERWISE
  retval := LTRIM( STR( S, 2 ) ) + ' Seconds'
ENDCASE

RETURN retval

*+--------------------------------------------------------------------
*+    Function JUL_DIFF()
*+    Called from ( julian.prg   )   1 - function jul_ave()
*+       Calls    ( julian.prg   )   7 - function prb_int()
*+--------------------------------------------------------------------
FUNCTION JUL_DIFF( Jul1, OFFSET )

LOCAL D := PRB_INT( Jul1 )
LOCAL S := VAL( RIGHT( STR( Jul1, 14, 5 ), 5 ) ) + ( PRB_INT( OFFSET * 60 ) )

IF S < 0
  D -= PRB_INT( ABS( S ) / 86400 ) + 1
  S := PRB_INT( ABS( S ) % 86400 )
ELSEIF S > 86399
  D += PRB_INT( S / 86400 )
  S := PRB_INT( S % 86400 )
ENDIF

RETURN PRB_INT( D + ( S / 100000 ),, 5 )

*+--------------------------------------------------------------------
*+    Function JUL_BTW()
*+--------------------------------------------------------------------
FUNCTION JUL_BTW( Jul1, Jul2, Unk )

RETURN ( Jul1 <= Unk ) .AND. ( Unk <= Jul2 )

*+--------------------------------------------------------------------
*+    Function JUL_BTWX()
*+--------------------------------------------------------------------
FUNCTION JUL_BTWX( Jul1, Jul2, Unk )

RETURN ( Jul1 < Unk ) .AND. ( Unk < Jul2 )

*+--------------------------------------------------------------------
*+    Function JUL_SEEK()
*+       Calls    ( julian.prg   )   2 - function diff2jul()
*+--------------------------------------------------------------------
FUNCTION JUL_SEEK( Jul1, Jul2, Unk )

RETURN IIF( DIFF2JUL( Jul1, Unk ) < DIFF2JUL( Jul2, Unk ), 1, 2 )

*+--------------------------------------------------------------------
*+    Function JUL_AVE()
*+       Calls    ( julian.prg   )   1 - function diff2jul()
*+                ( julian.prg   )   1 - function jul_diff()
*+--------------------------------------------------------------------
FUNCTION JUL_AVE( Jul1, Jul2 )

LOCAL DIFF := DIFF2JUL( MIN( Jul1, Jul2 ), MAX( Jul1, Jul2 ) )
LOCAL H    := VAL( LEFT( DIFF, 7 ) )
LOCAL M    := VAL( SUBSTR( DIFF, 9, 2 ) )
LOCAL S    := VAL( SUBSTR( DIFF, 12, 2 ) )

RETURN JUL_DIFF( MIN( Jul1, Jul2 ), ( ( S / 60 ) + M + ( H * 60 ) ) / 2 )

*+--------------------------------------------------------------------
*+    Function TTOS()
*+    Called from ( julian.prg   )   1 - function td2jul()
*+--------------------------------------------------------------------
FUNCTION TTOS( cTime )

RETURN ( VAL( SUBSTR( cTime, 7, 2 ) ) ) + ;
  ( VAL( SUBSTR( cTime, 4, 2 ) ) * 60 ) + ;
  ( VAL( SUBSTR( cTime, 1, 2 ) ) * 3600 )

*+--------------------------------------------------------------------
*+    Function TTOMS()
*+--------------------------------------------------------------------
FUNCTION TTOMS( cTime )

RETURN ( VAL( SUBSTR( cTime, 7, 2 ) ) / 60 ) + ;
  ( VAL( SUBSTR( cTime, 4, 2 ) ) ) + ;
  ( VAL( SUBSTR( cTime, 1, 2 ) ) * 60 )

*+--------------------------------------------------------------------
*+    Function TTOM()
*+--------------------------------------------------------------------
FUNCTION TTOM( cTime )

RETURN ( VAL( SUBSTR( cTime, 4, 2 ) ) ) + ;
  ( VAL( SUBSTR( cTime, 1, 2 ) ) * 60 )

*+--------------------------------------------------------------------
*+    Function MINS2HUND()
*+--------------------------------------------------------------------
FUNCTION MINS2HUND( nMinutes )

RETURN nMinutes / 60

*+--------------------------------------------------------------------
*+    Function PRB_INT()
*+    Called from ( julian.prg   )   1 - function td2jul()
*+                                   2 - function jul2time()
*+                                   1 - function jul2date()
*+                                   8 - function diff2jul()
*+                                   7 - function jul_diff()
*+--------------------------------------------------------------------
FUNCTION PRB_INT( nSomeNumber, nLength, nDecimals )

LOCAL lNegative   := ( nSomeNumber < 0 )
LOCAL cSomeString
LOCAL nDotAt

DEFAULT nDecimals TO 0
DEFAULT nLength TO 19

IF lNegative
  nSomeNumber := ABS( nSomeNumber )
ENDIF

nSomeNumber += .0000000000000005

cSomeString := ALLTRIM( STR( nSomeNumber ) )

nDotAt := AT( '.', cSomeString )

IF nDecimals > 0
  IF nDotAt > 0
    cSomeString := LEFT( cSomeString, nDotAt + nDecimals )
  ENDIF
ELSE
  IF nDotAt > 0
    cSomeString := LEFT( cSomeString, nDotAt - 1 )
  ENDIF
ENDIF

IF lNegative
  cSomeString := '-' + cSomeString
ENDIF

RETURN VAL( cSomeString )

*+--------------------------------------------------------------------
*+    Function JUL_PACK()
*+--------------------------------------------------------------------
FUNCTION JUL_PACK( nJulian )

LOCAL cJulian  := STRTRAN( STRZERO( nJulian, 11, 5 ), '.' )
LOCAL cPackJul := ''
LOCAL x

FOR x := 1 TO 10 step 2
  cPackJul += CHR( VAL( SUBSTR( cJulian, x, 2 ) ) )
NEXT

RETURN cPackJul

*+--------------------------------------------------------------------
*+    Function JUL_UNPACK()
*+--------------------------------------------------------------------
FUNCTION JUL_UNPACK( cPackJul )

LOCAL cJulian := ''
LOCAL x

FOR x := 1 TO 5
  cJulian += STRZERO( ASC( SUBSTR( cPackJul, x, 1 ) ), 2 )
NEXT

RETURN VAL( LEFT( cJulian, 5 ) + '.' + SUBSTR( cJulian, 6, 5 ) )

*+ EOF: julian.prg
