*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/obufread.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function BInit()
*+               Function Bopen()
*+               Function BReadLine()
*+               Function BNextLine()
*+               STATIC Function BDisk2Buff()
*+               Function BEof()
*+               Function BClose()
*+               Function BPosition()
*+               Function BRelative()
*+               Function BLineNumber()
*+               Function BGetSet()
*+               Function BRestSet()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include 'fileio.ch'
#include 'common.ch'

#define cFileName oBuffObj[ 1 ]
#define nAccMode oBuffObj[ 2 ]
#define cLineBuffer oBuffObj[ 3 ]
#define nHandle oBuffObj[ 4 ]
#define nBytesRead oBuffObj[ 5 ]
#define lFullBuff oBuffObj[ 6 ]
#define nTotBytes oBuffObj[ 7 ]
#define lIsOpen oBuffObj[ 8 ]
#define nFileBytes oBuffObj[ 9 ]
#define nFileLines oBuffObj[ 10 ]
#define cDelimiter oBuffObj[ 11 ]  //the eol character
#define BUFFLEN 2560
/*
function test( filename )

local oBuffObj1 := binit( filename )

if bopen( oBuffObj1 )
   do while !beof( oBuffObj1 )
      ? breadline( oBuffObj1 )
   enddo
   bclose( oBuffObj1 )
else
   ? 'Cannot open ' + filename
endif

return NIL
*/

*+--------------------------------------------------------------------
*+    Function BInit()
*+    Called from ( click.prg    )   3 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+                ( profile.prg  )   1 - STATIC function init_profile()
*+                ( readlnk.prg  )   2 - function readlnk()
*+--------------------------------------------------------------------
FUNCTION BInit( xFileName, xAccMode, ceoline )

// Function BInit( <cFileName>, [nAccessMode] )
// Return:  oBuffObj for this file access
// eol character, cdelimiter, needs to be set by bopen()
DEFAULT ceoline TO ''
RETURN { xFileName, xAccMode, '', - 1, 0, .t., 0, .t., 0, 0, ceoline }

*+--------------------------------------------------------------------
*+    Function Bopen()
*+    Called from ( click.prg    )   2 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+                ( profile.prg  )   1 - STATIC function init_profile()
*+                ( readlnk.prg  )   2 - function readlnk()
*+       Calls    ( obufread.prg )   1 - STATIC function bdisk2buff()
*+--------------------------------------------------------------------
FUNCTION Bopen( oBuffObj )

// Return:   .T. if file was opened
// Assumes:  All file access will be done with the B* functions

DEFAULT nAccMode TO FO_READ   // default access mode is Read Only

nHandle := FOPEN( cFileName, nAccMode )

nFileBytes := FSEEK( nHandle, 0, FS_END )

FSEEK( nHandle, 0, FS_SET )

BDisk2Buff( oBuffObj )  //read first 2500 bytes into buffer
DO CASE   //update the eol character from file if none is set
CASE LEN( ALLTRIM( cDelimiter ) ) > 0   //oBuffObj[11]
  //keep what was set when calling binit
CASE CHR( 13 ) + CHR( 10 ) $ cLineBuffer  //dos
  cDelimiter := CHR( 13 ) + CHR( 10 )
CASE CHR( 13 ) $ cLineBuffer  //mac
  cDelimiter := CHR( 13 )
CASE CHR( 10 ) $ cLineBuffer
  cDelimiter := CHR( 10 )   //linux
OTHERWISE   //last choice, use OS default newline
  cDelimiter := HB_OSNEWLINE()
ENDCASE

RETURN ( nHandle != - 1 )

*+--------------------------------------------------------------------
*+    Function BReadLine()
*+    Called from ( click.prg    )   2 - procedure click()
*+                                   1 - STATIC function breadpart()
*+                                   3 - STATIC procedure thealigner()
*+                ( declbust.prg )   4 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+                ( profile.prg  )   1 - STATIC function init_profile()
*+                ( readlnk.prg  )   2 - function readlnk()
*+       Calls    ( obufread.prg )   1 - STATIC function bdisk2buff()
*+--------------------------------------------------------------------
FUNCTION BReadLine( oBuffObj )

// Return:   The next line of the file read buffer
// Assumes:  The file pointer will be moved forward

LOCAL ThisLine
LOCAL nCrLfAt

DO WHILE .T.

  nCrLfAt := AT( cDelimiter, cLineBuffer )

  IF EMPTY( nCrLfAt ) .AND. lFullBuff
    BDisk2Buff( oBuffObj )
    LOOP
  ENDIF

  IF EMPTY( nCrLfAt )
    ThisLine    := STRTRAN( cLineBuffer, CHR( 26 ) )
    cLineBuffer := ''
  ELSE
    ThisLine    := LEFT( cLineBuffer, nCrLfAt - 1 )
    cLineBuffer := SUBSTR( cLineBuffer, nCrLfAt + LEN( cDelimiter ) )
  ENDIF

  EXIT

ENDDO

nFileLines ++

RETURN ThisLine   //eof BReadLine()

*+--------------------------------------------------------------------
*+    Function BNextLine()
*+    Called from ( click.prg    )   4 - STATIC procedure thealigner()
*+       Calls    ( obufread.prg )   1 - STATIC function bdisk2buff()
*+--------------------------------------------------------------------
FUNCTION BNextLine( oBuffObj )

// Return:   The next line of the file read buffer
// Assumes:  The file pointer will be left as last positioned

LOCAL NextLine
LOCAL nCrLfAt

//default cDelimiter to chr( 13 ) + chr( 10 ) 5/05

DO WHILE .T.

  nCrLfAt := AT( cDelimiter, cLineBuffer )

  IF EMPTY( nCrLfAt ) .AND. lFullBuff
    BDisk2Buff( oBuffObj )
    LOOP
  ENDIF

  IF EMPTY( nCrLfAt )
    NextLine := STRTRAN( cLineBuffer, CHR( 26 ) )
  ELSE
    NextLine := LEFT( cLineBuffer, nCrLfAt - 1 )
  ENDIF

  EXIT

ENDDO

RETURN NextLine

*+--------------------------------------------------------------------
*+    STATIC Function BDisk2Buff()
*+    Called from ( obufread.prg )   1 - function bopen()
*+                                   1 - function breadline()
*+                                   1 - function bnextline()
*+--------------------------------------------------------------------
STATIC FUNCTION BDisk2Buff( oBuffObj )

// Return:   .T. if there was no read error

STATIC cDiskBuffer := ''

IF LEN( cDiskBuffer ) != BUFFLEN
  cDiskBuffer := SPACE( BUFFLEN )
ENDIF

nBytesRead := FREAD( nHandle, @cDiskBuffer, BUFFLEN )

nTotBytes += nBytesRead   //oBuffObj[7]

lFullBuff := ( nBytesRead == BUFFLEN )  //oBuffObj[6]

IF lFullBuff
  cLineBuffer += cDiskBuffer  //oBuffObj[3]
ELSE
  cLineBuffer += LEFT( cDiskBuffer, nBytesRead )
ENDIF

RETURN FERROR()

*+--------------------------------------------------------------------
*+    Function BEof()
*+    Called from ( click.prg    )   3 - procedure click()
*+                                   2 - STATIC function breadpart()
*+                                   2 - STATIC procedure thealigner()
*+                ( declbust.prg )   2 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+                ( profile.prg  )   1 - STATIC function init_profile()
*+                ( readlnk.prg  )   2 - function readlnk()
*+--------------------------------------------------------------------
FUNCTION BEof( oBuffObj )

// Return:   TRUE  if End of buffered file
//           FALSE if not

RETURN !lFullBuff .AND. LEN( cLineBuffer ) == 0

*+--------------------------------------------------------------------
*+    Function BClose()
*+    Called from ( click.prg    )   2 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+                ( profile.prg  )   1 - STATIC function init_profile()
*+                ( readlnk.prg  )   2 - function readlnk()
*+--------------------------------------------------------------------
FUNCTION BClose( oBuffObj )

IF lIsOpen
  FCLOSE( nHandle )
  lIsOpen := .F.
ENDIF

oBuffObj := nil

RETURN FERROR()

*+--------------------------------------------------------------------
*+    Function BPosition()
*+    Called from ( obufread.prg )   1 - function brelative()
*+--------------------------------------------------------------------
FUNCTION BPosition( oBuffObj )

// Returns the position of virtual file pointer

RETURN nTotBytes - LEN( cLineBuffer )

*+--------------------------------------------------------------------
*+    Function BRelative()
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - STATIC function breadpart()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   1 - procedure func_text()
*+       Calls    ( obufread.prg )   1 - function bposition()
*+--------------------------------------------------------------------
FUNCTION BRelative( oBuffObj )

// Returns the percentage of file processed

RETURN BPosition( oBuffObj ) / nFileBytes

*+--------------------------------------------------------------------
*+    Function BLineNumber()
*+    Called from ( click.prg    )   2 - procedure click()
*+                                   1 - STATIC function breadpart()
*+                                   3 - STATIC procedure thealigner()
*+                ( declbust.prg )   4 - procedure declbust()
*+--------------------------------------------------------------------
FUNCTION BLineNumber( oBuffObj )

// Returns the current line number

RETURN nFileLines

*+--------------------------------------------------------------------
*+    Function BGetSet()
*+    Called from ( click.prg    )   1 - procedure click()
*+--------------------------------------------------------------------
FUNCTION BGetSet( oBuffObj )

RETURN ACLONE( oBuffObj )

*+--------------------------------------------------------------------
*+    Function BRestSet()
*+    Called from ( click.prg    )   1 - procedure click()
*+--------------------------------------------------------------------
FUNCTION BRestSet( oBuffObj )

FSEEK( nHandle, nTotBytes, FS_SET )

RETURN oBuffObj

*+ EOF: obufread.prg
