*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/obufwrit.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function bo_init()
*+               Function bo_open()
*+               Procedure bo_write()
*+               Procedure bo_writeNoDupe()
*+               Procedure bo_close()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include 'fileio.ch'
#include 'common.ch'

#define cFileName oObjData[ 1 ]
#define nAccMode oObjData[ 2 ]
#define cOutBuffer oObjData[ 3 ]
#define cOutBufLen oObjData[ 4 ]
#define nHandle oObjData[ 5 ]
#define lLastWasEmpty oObjData[ 6 ]
#define lRemoveDups oObjData[ 7 ]
//lIsOpen=8 not used
//nFileBytes=9 not used
//nFileLines=10 not used
#define cDelimiter oObjData[11]
#define BUFFLEN 2560

// This is a buffered write (output) routine that keeps the disk from
// thrashing on a bunch of little writes. This speeds up output
// dramatically.

*+--------------------------------------------------------------------
*+    Function bo_init()
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   5 - procedure func_text()
*+       Calls    ( profile.prg  )   1 - function profilestring()
*+--------------------------------------------------------------------
FUNCTION bo_init( xFileName, xAccMode, ceoline, cClickini )

//local cFullPath := if( file( 'CLICK.INI' ), 'CLICK', RootName( ft_origin() ) ) + '.ini'

DEFAULT ceoline TO HB_OSNEWLINE()
DEFAULT xAccMode TO FO_WRITE

RETURN { xFileName, ;
  xAccMode, ;
  '', ;
  0, ;
  - 1, ;
  .f., ;
  ProfileString( cClickini, 'CLICK', 'REMOVE_DUPLICATE_EMPTY_LINES', 'YES' ) == 'YES', ;
  .t., 0, 0, ceoline ;
  }

*+--------------------------------------------------------------------
*+    Function bo_open()
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   5 - procedure func_text()
*+--------------------------------------------------------------------
FUNCTION bo_open( oObjData )

BEGIN SEQUENCE
  IF !FILE( cFileName )
    nHandle := FCREATE( cFileName, FC_NORMAL )
    IF nHandle == - 1
      BREAK
    ENDIF
    FCLOSE( nHandle )
  ENDIF

  nHandle := FOPEN( cFileName, nAccMode )

  FSEEK( nHandle, 0, FS_END )

END SEQUENCE

RETURN nHandle # - 1

*+--------------------------------------------------------------------
*+    Procedure bo_write()
*+    Called from ( click.prg    )  22 - procedure click()
*+                                   2 - STATIC function breadpart()
*+                ( declbust.prg )  16 - procedure declbust()
*+                ( functrak.prg )  57 - procedure func_text()
*+--------------------------------------------------------------------
PROCEDURE bo_write( oObjData, cSomeText )

cOutBufLen += LEN( cSomeText )

cOutBuffer += cSomeText

IF cOutBufLen > BUFFLEN
  FWRITE( nHandle, cOutBuffer )
  cOutBuffer := ''
  cOutBufLen := 0
ENDIF

RETURN

*+--------------------------------------------------------------------
*+    Procedure bo_writeNoDupe()
*+    Called from ( click.prg    )  17 - STATIC procedure thealigner()
*+--------------------------------------------------------------------
PROCEDURE bo_writeNoDupe( oObjData, cSomeText )

IF !lRemoveDups .OR. cSomeText <> oObjData[ 11 ] .OR. ( cSomeText == oObjData[ 11 ] .AND. !lLastWasEmpty )

  cOutBufLen += LEN( cSomeText )

  cOutBuffer += cSomeText

  IF cOutBufLen > BUFFLEN
    FWRITE( nHandle, cOutBuffer )
    cOutBuffer := ''
    cOutBufLen := 0
  ENDIF

ENDIF

lLastWasEmpty := ( cSomeText == oObjData[ 11 ] )

RETURN

*+--------------------------------------------------------------------
*+    Procedure bo_close()
*+    Called from ( click.prg    )   1 - procedure click()
*+                                   1 - STATIC procedure thealigner()
*+                ( declbust.prg )   1 - procedure declbust()
*+                ( functrak.prg )   5 - procedure func_text()
*+--------------------------------------------------------------------
PROCEDURE bo_close( oObjData )

FWRITE( nHandle, cOutBuffer )

FCLOSE( nHandle )

RETURN

*+ EOF: obufwrit.prg
