*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/prb_pop.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Procedure POP_MSG()
*+               Procedure CLR_MSG()
*+               Procedure ATTENTION()
*+               Procedure CNT()
*+               Function c()
*+               Function Amaxstrlen()
*+               Function VERIFY()
*+               Function ASK_FOR()
*+               Procedure cls()
*+               Function FULLDATE()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include "common.ch"
#include "box.ch"
#include "set.ch"

STATIC THISSCRN
STATIC TL
STATIC BOXHIGH
STATIC cBox     := ".-.|'-`| "

*+--------------------------------------------------------------------
*+    Procedure POP_MSG()
*+    Called from ( click.prg    )   9 - procedure click()
*+                ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+       Calls    ( prb_pop.prg  )   1 - function amaxstrlen()
*+                ( prb_pop.prg  )   1 - procedure attention()
*+                ( prb_pop.prg  )   1 - procedure cnt()
*+--------------------------------------------------------------------
PROCEDURE POP_MSG( SOME_TXT, MSG_LOGIC, BORDCOLOR, MAINCOLOR )

LOCAL MAXLEN
LOCAL x
LOCAL ARLEN
LOCAL INCOLOR
LOCAL CROW
LOCAL CCOL
LOCAL LC

DEFAULT MSG_LOGIC TO .T.

DEFAULT BORDCOLOR TO 'B+/W'
DEFAULT MAINCOLOR TO 'N/W,W+/B'

IF !ISARRAY( SOME_TXT )
  SOME_TXT := { SOME_TXT }
ENDIF

ARLEN := LEN( SOME_TXT )

TL := ( MAXROW() / 2 ) - ( ( ARLEN / 2 ) + 2 )

MAXLEN := MIN( MAXCOL() - 4, MAX( Amaxstrlen( SOME_TXT ), 25 ) + 6 )

BOXHIGH  := ARLEN + 2
THISSCRN := SAVESCREEN( TL - 2, 0, BOXHIGH + TL + 1, MAXCOL() )
CROW     := ROW()
CCOL     := COL()

LC := INT( ( MAXCOL() - MAXLEN ) / 2 )

//dispbox( TL - 1, LC, BOXHIGH + TL, LC + MAXLEN - 1, B_DOUBLE_SINGLE + ' ', BORDCOLOR )
DISPBOX( TL - 1, LC, BOXHIGH + TL, LC + MAXLEN - 1, cBox, BORDCOLOR )

DISPBEGIN()

INCOLOR := SETCOLOR( MAINCOLOR )

FOR x := 1 TO ARLEN
  CNT( SOME_TXT[ x ], TL + x )
NEXT

DISPEND()

IF MSG_LOGIC
  ATTENTION( 'Press any key to continue', BOXHIGH + TL )
  INKEY( 0 )
  RESTSCREEN( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )
  THISSCRN := ''
  DEVPOS( CROW, CCOL )
ENDIF

SETCOLOR( INCOLOR )

RETURN

*+--------------------------------------------------------------------
*+    Procedure CLR_MSG()
*+    Called from ( prb_pop.prg  )   1 - function verify()
*+                                   1 - function ask_for()
*+--------------------------------------------------------------------
PROCEDURE CLR_MSG()

RESTSCREEN( TL - 2, 0, BOXHIGH + TL + 1, 79, THISSCRN )

THISSCRN := ''

RETURN

*+--------------------------------------------------------------------
*+    Procedure ATTENTION()
*+    Called from ( filnpath.prg )   1 - function createini()
*+                                   1 - function createhdr()
*+                ( prb_pop.prg  )   1 - procedure pop_msg()
*+       Calls    ( prb_pop.prg  )   1 - function c()
*+--------------------------------------------------------------------
PROCEDURE ATTENTION( CSTRING, NLINENUM, CCOLOR )

LOCAL COLDCOLOR

DEFAULT NLINENUM TO 24
DEFAULT CCOLOR TO 'GR+/R'

COLDCOLOR := SETCOLOR( CCOLOR )

CSTRING := '  ' + ALLTRIM( CSTRING ) + '  '

DEVPOS( NLINENUM, c( CSTRING ) )

DEVOUT( CSTRING )

SETCOLOR( COLDCOLOR )

RETURN

*+--------------------------------------------------------------------
*+    Procedure CNT()
*+    Called from ( prb_pop.prg  )   1 - procedure pop_msg()
*+       Calls    ( prb_pop.prg  )   1 - function c()
*+--------------------------------------------------------------------
PROCEDURE CNT( CSTRING, NLINENUM )

DEVPOS( NLINENUM, c( CSTRING ) )

DEVOUT( CSTRING )

RETURN

*+--------------------------------------------------------------------
*+    Function c()
*+    Called from ( prb_pop.prg  )   1 - procedure attention()
*+                                   1 - procedure cnt()
*+                                   2 - function ask_for()
*+--------------------------------------------------------------------
FUNCTION c( CSTRING )

RETURN MAX( ( MAXCOL() / 2 ) - INT( LEN( CSTRING ) / 2 ), 0 )

*+--------------------------------------------------------------------
*+    Function Amaxstrlen()
*+    Called from ( prb_pop.prg  )   1 - procedure pop_msg()
*+--------------------------------------------------------------------
FUNCTION Amaxstrlen( ANARRAY )

LOCAL ARLEN
LOCAL THISLEN
LOCAL max     := 0
LOCAL x

IF ISARRAY( ANARRAY )

  ARLEN := LEN( ANARRAY )

  FOR x := 1 TO ARLEN
    THISLEN := LEN( ANARRAY[ X ] )
    IF THISLEN > max
      max := THISLEN
    ENDIF
  NEXT

ENDIF

RETURN max

*+--------------------------------------------------------------------
*+    Function VERIFY()
*+    Called from ( click.prg    )   4 - procedure click()
*+       Calls    ( prb_pop.prg  )   1 - procedure clr_msg()
*+                ( prb_pop.prg  )   1 - procedure pop_msg()
*+--------------------------------------------------------------------
FUNCTION VERIFY( SOME_TXT, LNORMANS, YES_PRMPT, NO_PRMPT, BORDCOLOR, MAINCOLOR )

LOCAL INCOLOR
LOCAL VERI
LOCAL ARLEN
DEFAULT BORDCOLOR TO 'W+/R'
DEFAULT MAINCOLOR TO 'W+/R,W+/B'

LNORMANS  := IIF( VALTYPE( LNORMANS ) = "L", LNORMANS, .T. )
YES_PRMPT := IIF( YES_PRMPT = NIL, ' YES ', ' ' + ALLTRIM( YES_PRMPT ) + ' ' )
NO_PRMPT  := IIF( NO_PRMPT = NIL, ' NO ', ' ' + ALLTRIM( NO_PRMPT ) + ' ' )

IF !ISARRAY( SOME_TXT )
  SOME_TXT := { SOME_TXT }
ENDIF

ARLEN := LEN( SOME_TXT ) + 2

ASIZE( SOME_TXT, ARLEN )

SOME_TXT[ ARLEN - 1 ] := ''
SOME_TXT[ ARLEN ]     := ''

POP_MSG( SOME_TXT, .f., BORDCOLOR, MAINCOLOR )

VERI := IIF( LNORMANS, 1, 2 )

INCOLOR := SETCOLOR( MAINCOLOR )
@ TL - 2 + BOXHIGH, 33 - ( LEN( YES_PRMPT ) / 2 ) PROMPT YES_PRMPT
@ TL - 2 + BOXHIGH, 46 - ( LEN( NO_PRMPT ) / 2 ) PROMPT NO_PRMPT

MENU TO VERI

clr_msg()

SETCOLOR( INCOLOR )

RETURN ( VERI == 1 )

*+--------------------------------------------------------------------
*+    Function ASK_FOR()
*+       Calls    ( prb_pop.prg  )   2 - function c()
*+                ( prb_pop.prg  )   1 - procedure clr_msg()
*+                ( prb_pop.prg  )   1 - procedure pop_msg()
*+--------------------------------------------------------------------
FUNCTION ASK_FOR( SOME_TXT, Getvar, PICVAR, BORDCOLOR, MAINCOLOR )

LOCAL GETLIST := {}

LOCAL INCOLOR  := SETCOLOR()
LOCAL INCURSOR := SET( _SET_CURSOR )
LOCAL ARLEN
LOCAL VCNT
LOCAL RETVAL
LOCAL CROW     := ROW()
LOCAL CCOL     := COL()

DEFAULT BORDCOLOR TO 'G+/GR'
DEFAULT MAINCOLOR TO 'GR+/GR,W+/B,,,W+/N'

IF !ISARRAY( SOME_TXT )
  SOME_TXT := { SOME_TXT }
ENDIF

ARLEN := LEN( SOME_TXT ) + 2

ASIZE( SOME_TXT, ARLEN )

DO CASE
CASE ISCHARACTER( Getvar )
  VCNT := c( Getvar )
CASE ISDATE( Getvar )
  VCNT := 35
CASE ISNUMBER( Getvar )
  VCNT := c( PICVAR )
OTHERWISE
  VCNT := MAXCOL() / 2
ENDCASE

SOME_TXT[ ARLEN - 1 ] := ''
SOME_TXT[ ARLEN ]     := SPACE( ( ( MAXCOL() / 2 ) - VCNT ) * 2 )

POP_MSG( SOME_TXT, .f., BORDCOLOR, MAINCOLOR )

SETCOLOR( MAINCOLOR )

IF ISDATE( Getvar )
  @ TL + BOXHIGH - 2, VCNT GET Getvar
ELSE
  @ TL + BOXHIGH - 2, VCNT GET Getvar PICTURE PICVAR
ENDIF

SET CURSOR ( .T. )
READ
SET( _SET_CURSOR, INCURSOR )

clr_msg()

RETVAL := Getvar

IF ISCHARACTER( Getvar )
  Getvar := ALLTRIM( Getvar )
ENDIF

SETCOLOR( INCOLOR )
DEVPOS( CROW, CCOL )

RETURN RETVAL

*+--------------------------------------------------------------------
*+    Procedure cls()
*+--------------------------------------------------------------------
PROCEDURE CLS( NEWCOLOR, BKGCHR )

DEFAULT NEWCOLOR TO 'GB+/N,R/W,,,W+/N'
DEFAULT BKGCHR TO 177

SETCOLOR( NEWCOLOR )

//dispbox( 0, 0, maxrow(), maxcol(), replicate( chr( BKGCHR ), 9 ) )
DISPBOX( 0, 0, MAXROW(), MAXCOL(), cBox )

RETURN

*+--------------------------------------------------------------------
*+    Function FULLDATE()
*+--------------------------------------------------------------------
FUNCTION FULLDATE( ANYDATE )

DEFAULT ANYDATE TO DATE()

RETURN CMONTH( ANYDATE ) + ' ' + LTRIM( STR( DAY( ANYDATE ), 2 ) ) + ', ' + STR( YEAR( ANYDATE ), 4 )

*+ EOF: prb_pop.prg
