*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/readlnk.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function readlnk()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

*+--------------------------------------------------------------------
*+    Function readlnk()
*+    Called from ( click.prg    )   1 - procedure click()
*+       Calls    ( obufread.prg )   2 - function bclose()
*+                ( obufread.prg )   2 - function beof()
*+                ( obufread.prg )   2 - function binit()
*+                ( obufread.prg )   2 - function bopen()
*+                ( obufread.prg )   2 - function breadline()
*+                ( filnpath.prg )   2 - function fileinpath()
*+                ( token.prg    )   2 - function numtoken()
*+                ( click.prg    )   3 - function rootname()
*+                ( token.prg    )   2 - function numtoken()
*+--------------------------------------------------------------------
FUNCTION readlnk( cFileName )

LOCAL hi
LOCAL nx
LOCAL w
LOCAL x
LOCAL y
LOCAL nY
LOCAL nFilePointer
LOCAL nPointer
LOCAL aFileList    := {}
LOCAL aLibList     := {}
LOCAL aLinkList    := { UPPER( cFileName ) }
LOCAL aFileDone    := { .f. }
LOCAL cThisLine
LOCAL cThisFile

// we start this loop with the .LNK list we specified at runtime as the
// only entry, and mark it .F. for not processed. As we process this
// entry, we may come upon one or more references to other link scripts.
// If this is the case, they are added to the processing array and
// marked as not processed. When all have been processed, we have a
// complete list. It's easier than recursion.

DO WHILE .T.

  nFilePointer := ASCAN( aFileDone, .f. )

  // If 0, we finished finding and processing all .LNK files
  IF nFilePointer == 0
    EXIT
  ENDIF

  hi := binit( aLinkList[ nFilePointer ] )
  IF bopen( hi )

    DO WHILE !beof( hi )

      cThisLine := UPPER( LTRIM( bReadLine( hi ) ) )

      IF LEFT( cThisLine, 1 ) == '@'
        // grab the filename
        cThisLine := SUBSTR( cThisLine, 2 )

        // strip comments
        IF ( nPointer := AT( '#', cThisLine ) ) > 0
          cThisLine := LEFT( cThisLine, nPointer - 1 )
        ENDIF

        // trim any spaces
        cThisLine := ALLTRIM( cThisLine )

        // check to see if this name is already in the list
        IF ( nPointer := ASCAN( aLinkList, cThisLine ) ) == 0

          // force the extension
          cThisFile := rootname( cThisLine ) + '.LNK'

          // is it in the current directory?
          IF !FILE( cThisFile )
            // is it in the LIB= path?
            cThisFile := fileinpath( cThisFile, 'LIB' )
          ENDIF

          // if it was not found in local dir or path, it is empty.
          IF !EMPTY( cThisFile )
            AADD( aLinkList, cThisFile )
            AADD( aFileDone, .f. )
          ENDIF
        ENDIF

      ENDIF

    ENDDO

    bClose( hi )

  ENDIF

  aFileDone[ nFilePointer ] := .T.

ENDDO

// once we have the link scripts all of them need to be scanned for
// library references and for source references. Library references are
// checked for validity against the environment, and program files are
// checked for existance in the local directory.

nY := LEN( aLinkList )

FOR y := 1 TO nY
  hi := binit( aLinkList[ y ] )
  IF bopen( hi )
    DO WHILE !beof( hi )
      cThisLine := UPPER( ALLTRIM( bReadLine( hi ) ) )
      IF ( nPointer := AT( '#', cThisLine ) ) > 0
        cThisLine := TRIM( LEFT( cThisLine, nPointer - 1 ) )
      ENDIF
      IF LEFT( cThisLine, 2 ) $ 'LI|AL'
        cThisLine := ALLTRIM( SUBSTR( cThisLine, AT( ' ', cThisLine ) ) )
        IF !EMPTY( cThisLine )
          nx := numtoken( cThisLine, ',' )
          FOR x := 1 TO nx
            cThisFile := UPPER( token( cThisLine, ',', x ) )
            AADD( aLibList, fileinpath( rootname( cThisFile ) + '.LIB' ) )
          NEXT
        ENDIF
      ENDIF
      IF LEFT( cThisLine, 2 ) == 'FI'
        cThisLine := ALLTRIM( SUBSTR( cThisLine, AT( ' ', cThisLine ) ) )
        IF !EMPTY( cThisLine )
          nx := numtoken( cThisLine, ',' )
          FOR x := 1 TO nx
            cThisFile := token( cThisLine, ',', x )
            w         := RAT( '/', cThisFile )
            IF w > 0
              cThisFile := SUBSTR( cThisFile, w + 1 )
            ENDIF
            cThisFile := rootname( cThisFile ) + '.PRG'
            IF FILE( cThisFile )
              AADD( aFileList, cThisFile )
            ENDIF
          NEXT
        ENDIF
      ENDIF
    ENDDO
    bclose( hi )
  ENDIF
NEXT

// Exiting this routine, we have a pair of validated arrays which
// contain a list of all libraries and all files referred to in the
// link script being examined.

RETURN { aFileList, aLibList }

*+ EOF: readlnk.prg
