*+--------------------------------------------------------------------
*+    Source Module => /home/paul/click/token.prg
*+    Click! is a Clipper/Xbase++ source code reformatter.
*+    Note:Phil is no longer actively developing Click!.
*+    Copyright(C) 1996-1999 by Phil Barnett.
*+    This program is free software; you can redistribute it and/or modify it
*+    under the terms of the GNU General Public License as published by the
*+    Free Software Foundation; either version 2 of the License, or (at your
*+    option) any later version.
*+    This program is distributed in the hope that it will be useful, but
*+    WITHOUT ANY WARRANTY; without even the implied warranty of
*+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*+    General Public License for more details.
*+    You should have received a copy of the GNU General Public License along
*+    with this program; if not, contact the Free Software Foundation, Inc.,
*+    51 Franklin St, Fifth Floor Boston, MA 02110, USA, or www.fsf.org.
*+    You can contact me at:
*+    Phil Barnett
*+    Box 944
*+    Plymouth, Florida  32768
*+    or
*+    philb@iag.net
*+    Ported to Linux and xHarbour compiler, minor feature additions.
*+    Changed version to 3.00xHarbour  Changes
*+    GPL version 3 Copyright (C) 2006-9 by Paul States
*+    Contact:broadcastmail AT NOSPAM 123mail.org.
*+    Functions: Function numtoken()
*+               Function token()
*+    Reformatted by Click! 3.00Harbour on Apr-13-2009 at  2:30 pm
*+--------------------------------------------------------------------

#include "common.ch"

/*
*+
*+    Function test()
*+
function test()

local x
local nHowMany       := numtoken( '  This    is   a  test,   eh?  ', ' ' )

? nHowMany

for x := 1 to nHowMany
   ? '<' + token( '  This    is   a  test,   eh?  ', ' ', x ) + '>'
next

? numtoken( '             ', ' ' )

? numtoken( '', ' ' )

return nil
*/

*+--------------------------------------------------------------------
*+    Function numtoken()
*+    Called from ( click.prg    )   1 - function lineparse()
*+                ( filnpath.prg )   1 - function fileinpath()
*+                ( functrak.prg )   2 - procedure init_func_text()
*+                ( libread.prg  )   1 - procedure libread()
*+                ( readlnk.prg  )   2 - function readlnk()
*+--------------------------------------------------------------------
FUNCTION numtoken( cString, cDelimiter )

// This is used to get a count of how many tokens are in a string based
// on the supplied delimiter. This defaults to the same delimiters as
// used in the like named function in Clipper Tools III, so it should
// work identically.

LOCAL x
LOCAL nStrLen    := LEN( cString )
LOCAL nHowMany   := 0
LOCAL lFoundWord := .F.
LOCAL retval     := 0

DEFAULT cDelimiter TO ' ,.;:!?/\<>()^#&%+-*' + CHR( 0 ) + CHR( 9 ) + ;
  CHR( 10 ) + CHR( 13 ) + ;
  CHR( 26 ) + CHR( 138 ) + ;
  CHR( 141 )

FOR x := 1 TO nStrLen
  IF SUBSTR( cString, x, 1 ) $ cDelimiter
    IF lFoundWord
      nHowMany ++
    ENDIF
    DO WHILE x < nStrLen .AND. SUBSTR( cString, x + 1, 1 ) $ cDelimiter
      x ++
    ENDDO
  ELSE
    lFoundWord := .T.
  ENDIF
NEXT

IF nStrLen > 0
  retval := IIF( RIGHT( cString, 1 ) $ cDelimiter, nHowmany, nHowMany + 1 )
ENDIF

RETURN retval

*+--------------------------------------------------------------------
*+    Function token()
*+    Called from ( click.prg    )   1 - function lineparse()
*+                ( filnpath.prg )   1 - function fileinpath()
*+                ( functrak.prg )   2 - procedure init_func_text()
*+                ( libread.prg  )   1 - procedure libread()
*+                ( readlnk.prg  )   2 - function readlnk()
*+--------------------------------------------------------------------
FUNCTION token( cString, cDelimiter, nPointer )

// This is used to extract each token from the string based on the
// delimiter and the numeric pointer which tells us which token to
// return.

// This defaults to the same delimiters as used in the like named
// function in Clipper Tools III, so it should work identically.

LOCAL x
LOCAL nStrLen      := LEN( cString )
LOCAL nHowMany     := 0
LOCAL nLastPointer := 0
LOCAL cPart
LOCAL lFoundWord   := .F.

DEFAULT cDelimiter TO ' ,.;:!?/\<>()^#&%+-*' + CHR( 0 ) + CHR( 9 ) + ;
  CHR( 10 ) + CHR( 13 ) + ;
  CHR( 26 ) + CHR( 138 ) + ;
  CHR( 141 )

FOR x := 1 TO nStrLen
  IF SUBSTR( cString, x, 1 ) $ cDelimiter
    IF lFoundWord
      nHowMany ++
    ENDIF
    IF nHowMany == nPointer
      EXIT
    ENDIF
    DO WHILE x < nStrLen .AND. SUBSTR( cString, x + 1, 1 ) $ cDelimiter
      x ++
    ENDDO
    nLastPointer := x
  ELSE
    lFoundWord := .T.
  ENDIF
NEXT

// went all the way without nHowmany == nPointer
IF x == nStrLen + 1
  // take the last word
  cPart := SUBSTR( cString, nLastPointer + 1 )
ELSE
  cPart := SUBSTR( cString, nLastPointer + 1, ( x - nLastPointer ) - 1 )
ENDIF

RETURN cPart

*+ EOF: token.prg
